unit mimapulse_graphe;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  Buttons, StdCtrls,
  //Copie écran
  ClipBrd, //ClipBoard
  LCLIntf, //GetDC
  LCLType; //HDC

type

  { TWdGraphe }

  TWdGraphe = class(TForm)
    CkL1: TCheckBox;
    EdDeb: TEdit;
    EdFin: TEdit;
    Img: TImage;
    Label1: TLabel;
    La4: TLabel;
    La5: TLabel;
    La6: TLabel;
    La14: TLabel;
    La15: TLabel;
    La16: TLabel;
    La25: TLabel;
    La26: TLabel;
    LaFin: TLabel;
    Label4: TLabel;
    La1: TLabel;
    La11: TLabel;
    La10: TLabel;
    La21: TLabel;
    La22: TLabel;
    La20: TLabel;
    La2: TLabel;
    La3: TLabel;
    La12: TLabel;
    La13: TLabel;
    La23: TLabel;
    La24: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    LaMax: TLabel;
    LaMin: TLabel;
    LaPulse: TLabel;
    Pa0: TPanel;
    PaLgFin: TPanel;
    PaZ: TPanel;
    Panel1: TPanel;
    PaEvMax: TPanel;
    PaEvMin: TPanel;
    PaCurseur: TPanel;
    PaLgDeb: TPanel;
    PaPos: TPanel;
    PaT: TPanel;
    PaXY: TPanel;
    PaEvPulse: TPanel;
    SpeedButton1: TSpeedButton;
    SpP20: TSpeedButton;
    SpDebut: TSpeedButton;
    SpM20: TSpeedButton;
    SpP1: TSpeedButton;
    SpM1: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpFin: TSpeedButton;
    procedure CkL1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ImgMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpP20Click(Sender: TObject);
    procedure SpM20Click(Sender: TObject);
    procedure SpDebutClick(Sender: TObject);
    procedure SpFinClick(Sender: TObject);
    procedure SpP1Click(Sender: TObject);
    procedure SpM1Click(Sender: TObject);
    procedure SpeedButton8Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  WdGraphe: TWdGraphe;

implementation

uses mimapulse_main;

{$R *.lfm}

{ TWdGraphe }

const
  Axes1MaxY_ = 160;
  Gr1DecalY_ = 40;

var
  //Graphe1
  Gr1CoefY: real;
  Gr1MaxX, Gr1MaxY: integer;
  GrFin0, GrFin: integer;
  //Moindres carrés
  Mc1Ydeb, Mc1Yfin: array[1..3] of integer;

procedure Gr1_Copie_Presse_Papier;
var
  Bitmap: TBitmap;
  ScreenDC: HDC;
begin
  with WdGraphe do
  begin
    //Copie vers Clipboard
    try
      Bitmap := TBitmap.Create;
      //Récupère le handle de la feuille
      ScreenDC := GetDC(handle);
      Bitmap.LoadFromDevice(ScreenDC);
      ReleaseDC(handle, ScreenDC);
      //Envoyer dans le Clipboard
      ClipBoard.Assign(Bitmap);
    finally
      Bitmap.Free;
    end;
  end;
end;

procedure Gr1_Img1_Clear;
const
  DeltaY_ = 40;
var
  n, x, y, x2, y2: integer;
begin
  with WdGraphe do
  begin
    with Img.Canvas do
    begin
      //Efface
      Pen.Color := ClCream;
      for x := 0 to Gr1MaxX do
        Line(x, 0, x, Gr1MaxY);
      //Affiche axes Y
      y := Gr1MaxY;
      n := 0;
      repeat
        case n of
          60, 80, 130: Pen.Color := ClBlue;
          else
            Pen.Color := ClSilver;
        end;
        y := Gr1MaxY - Round(n * Gr1CoefY);
        if n > 0 then
        begin
          Line(GrDecalX_, y, Gr1MaxX - GrDecalX_, y);
          case n of
            10..90: TextOut(11, y - 8, IntToStr(n));
            100..160: TextOut(3, y - 8, IntToStr(n));
          end;
          TextOut(Gr1MaxX - GrDecalX_, y - 8, IntToStr(n));
        end;
        Dec(y, DeltaY_);
        Inc(n, 10);
      until (n > 150) or (y < Gr1DecalY_);
      //Texte Maxima
      TextOut(GrDecalX_ + 4, Gr1MaxY - Round((140) * Gr1CoefY), '[Maxima]');
      //Texte Minima
      TextOut(GrDecalX_ + 4, Gr1MaxY - Round((90) * Gr1CoefY), '[Minima]');
      //Texte Pulsation
      TextOut(GrDecalX_ + 4, Gr1MaxY - Round((70) * Gr1CoefY), '[Pulsations]');
      //Ecarts Min/Max
      TextOut(GrDecalX_ + 320, Gr1MaxY - Round(
        (100) * Gr1CoefY), 'Ecart "Maxima/Minima" (Div. 5)');
      //Rectangle pour Infos tension
      x := 8 * GrDecalX_;
      y := Gr1MaxY - Round(25 * Gr1CoefY);
      x2 := Gr1MaxX - 8 * GrDecalX_;
      y2 := Gr1MaxY - Round(4 * Gr1CoefY);
      Pen.Color := ClSilver;
      Rectangle(x, y, x2, y2);
      y2 := Gr1MaxY - Round(17 * Gr1CoefY);
      Line(x, y2, x2, y2);
      x := 12 * GrDecalX_;
      y := Gr1MaxY - Round(25 * Gr1CoefY);
      y2 := Gr1MaxY - Round(04 * Gr1CoefY);
      Line(x, y, x, y2);
    end;
  end;
end;

procedure Gr1_Graphe_Affiche(GrFin: integer);
var
  //Tableau des données pour traitement
  Gr1XY: array[1..GrWinMax_, 1..3] of integer;
  //Ecarts
  Gr1Ecarts: array[1..GrWinMax_] of integer;
  //Champs vides
  Erreurs: integer;

  function ConvertEcran(y: integer): integer;
  begin
    Result := Gr1MaxY - Round(y * Gr1CoefY);
  end;

  procedure Gr1_Traitement_des_donnees(Debut, Fin: integer);
  var
    n, p: integer;
  begin
    with WdGraphe do
    begin
      Gr1Ecarts[1] := 0;
      p := 1;
      for n := Debut to Fin do
      begin
        //Maxima
        Gr1XY[p, 1] := WdMain.Convert(WdMain.StringGrid1.Cells[3, n]);
        //Minima
        Gr1XY[p, 2] := WdMain.Convert(WdMain.StringGrid1.Cells[4, n]);
        //Pulsations
        Gr1XY[p, 3] := WdMain.Convert(WdMain.StringGrid1.Cells[5, n]);
        //Ecarts
        Gr1Ecarts[p] := Gr1XY[p, 1] - Gr1XY[p, 2];
        Inc(p);
      end;
      //Traitement pour affichage
      for n := 1 to GrWinMax_ do
      begin
        //Maxima
        if Gr1XY[n, 1] > 0 then
        begin
          Gr1XY[n, 1] := Gr1MaxY - Round(Gr1XY[n, 1] * Gr1CoefY);
        end
        else
        begin
          Gr1XY[n, 1] := Gr1MaxY - Round(GrMoyMaxi_ * Gr1CoefY);
          Inc(Erreurs);
        end;
        //Minima
        if Gr1XY[n, 2] > 0 then
        begin
          Gr1XY[n, 2] := Gr1MaxY - Round(Gr1XY[n, 2] * Gr1CoefY);
        end
        else
        begin
          Gr1XY[n, 2] := Gr1MaxY - Round(GrMoyMini_ * Gr1CoefY);
          Inc(Erreurs);
        end;
        //Pulsations
        if Gr1XY[n, 3] > 0 then
        begin
          Gr1XY[n, 3] := Gr1MaxY - Round(Gr1XY[n, 3] * Gr1CoefY);
        end
        else
        begin
          Gr1XY[n, 3] := Gr1MaxY - Round(GrMoyPulse_ * Gr1CoefY);
          Inc(Erreurs);
        end;
      end;
      //Erreurs
      if Erreurs > 0 then
      begin
        PaZ.Color := $008888FF;
        PaZ.Font.Color := ClBlack;
        PaZ.Caption := IntToStr(Erreurs);
      end
      else
      begin
        PaZ.Color := $00C4FFC4;
        PaZ.Font.Color := ClBlue;
        PaZ.Caption := '0';
      end;
    end;
  end;

  procedure Gr1_Affichage(Debut, Fin: integer);

    function EcartCol(Ec: integer): TColor;
    var
      Col: TColor;
    begin
      if Ec > 50 then
      begin
        Col := $000080FF;
      end
      else
      begin
        if Ec < 40 then
          Col := clAqua
        else
          Col := clBlue;
      end;
      Result := Col;
    end;

  var
    Gr1XYMem: array[1..3] of integer;
    LesMem: array[1..3] of integer;
    Les: integer;
    n, p, x, y1, y2: integer;
  begin
    with WdGraphe do
    begin
      PaCurseur.Left := Round(0.2 * Fin) - 36;
      with Img.Canvas do
      begin
        //Mem début
        for p := 1 to 3 do
        begin
          Gr1XYMem[p] := Gr1XY[1, p];
          LesMem[p] := WdMain.LES_3(Alpha_, Gr1XY[4, p], Gr1XY[3, p], Gr1XY[2, p], Gr1XY[1, p]);
        end;
        //-
        //1er Ecart
        x := 1;
        y1 := Gr1MaxY - Round(100 * Gr1CoefY);
        y2 := y1 - Round((Gr1Ecarts[1] / 5) * Gr1CoefY);
        Pen.Color := EcartCol(Gr1Ecarts[1]);
        Line(x, y1, x, y2);
        //Affichage
        n := 2;
        x := 5;
        for n := 2 to GrWinMax_ do
        begin
          if x < Gr1MaxX then
          begin
            //Graphe
            for p := 1 to 3 do
            begin
              case CkL1.Checked of
                True: Pen.Color := ClSilver;
                False: Pen.Color := ClBlack;
              end;
              Line(GrDecalX_ + x - 4, Gr1XYMem[p], GrDecalX_ + x, Gr1XY[n, p]);
              //Lissage
              if CkL1.Checked then
              begin
                if n > 3 then
                begin
                  Pen.Color := ClBlack;
                  Les := WdMain.LES_3(Alpha_, y2, Gr1XY[n - 1, p], Gr1XY[n - 2, p], Gr1XY[n - 3, p]);
                  case p of
                    1:
                    begin
                      Line(GrDecalX_ + x - 4, LesMem[p] + 40, GrDecalX_ + x, Les + 40);
                      Line(GrDecalX_ + x - 4, LesMem[p] + 41, GrDecalX_ + x, Les + 41);
                    end;
                    2:
                    begin
                      Line(GrDecalX_ + x - 4, LesMem[p] + 185, GrDecalX_ + x, Les + 185);
                      Line(GrDecalX_ + x - 4, LesMem[p] + 186, GrDecalX_ + x, Les + 186);
                    end;
                    3:
                    begin
                      Line(GrDecalX_ + x - 4, LesMem[p] + 255, GrDecalX_ + x, Les + 255);
                      Line(GrDecalX_ + x - 4, LesMem[p] + 256, GrDecalX_ + x, Les + 256);
                    end;
                  end;
                  LesMem[p] := Les;
                end;
              end;
            end;
          end;
          //Ecarts
          y2 := y1 - Round((Gr1Ecarts[n] / 5) * Gr1CoefY);
          Pen.Color := EcartCol(Gr1Ecarts[n]);
          Line(GrDecalX_ + x, y1, GrDecalX_ + x, y2);
          //-
          for p := 1 to 3 do
            Gr1XYMem[p] := Gr1XY[n, p];
          Inc(x, 4);
        end;
      end;
    end;
  end;

  procedure Gr1_Regression_lineaire_Init(Debut, Fin: integer);
  var
    a, b: real;
    n: integer;
  begin
    //----- Régression linéaire par la méthode des moindres carrés -----
    //Calcul de la droite y = a * x + b
    //Détermination de a et b, ainsi que Ydébut et Yfin
    //Init.
    for n := 1 to 3 do
    begin
      a := 0;
      b := 0;
      Mc1Ydeb[n] := 0;
      Mc1Yfin[n] := 0;
      WdMain.Moindres_carres(n, Debut, Fin, a, b, Mc1Ydeb[n], Mc1Yfin[n]);
      //Y : Debut, Fin
      Mc1Ydeb[n] := Round((a * Mc1Ydeb[n]) + b);
      Mc1Yfin[n] := Round((a * Mc1Yfin[n]) + b);
    end;
  end;

  procedure Gr1_Regression_lineaire_Affichage;
  var
    n, Yd, Yf: integer;
  begin
    //Régression linéaire, affichage de la droite
    with WdGraphe do
    begin
      with Img.Canvas do
      begin
        Pen.Color := ClFuchsia;
        for n := 1 to 3 do
        begin
          if Mc1Yfin[n] > 0 then
          begin
            //Début, Fin
            Yd := ConvertEcran(Mc1Ydeb[n]);
            Yf := ConvertEcran(Mc1Yfin[n]);
            //Affichage
            Line(GrDecalX_, Yd, Gr1MaxX - GrDecalX_, Yf);
            Line(GrDecalX_, Yd, (Gr1MaxX - GrDecalX_) + 1, Yf);
            case n of
              1: PaEvMax.Caption := IntToStr(Mc1Yfin[n]);
              2: PaEvMin.Caption := IntToStr(Mc1Yfin[n]);
              3: PaEvPulse.Caption := IntToStr(Mc1Yfin[n]);
            end;
          end
          else
          begin
            case n of
              1: PaEvMax.Caption := '';
              2: PaEvMin.Caption := '';
              3: PaEvPulse.Caption := '';
            end;
          end;
        end;
      end;
    end;
  end;

var
  Debut, Fin: integer;
begin
  with WdGraphe do
  begin
    Fin := GrFin;
    if Fin < GrWinMax_ then
      Fin := GrWinMax_;
    Debut := Fin - GrWinMax_ + 1;
    if Debut < 1 then
      Debut := 1;
    //-
    EdDeb.Text := WdMain.StringGrid1.Cells[1, Debut] +
      ' ' + WdMain.StringGrid1.Cells[2, Debut];
    EdFin.Text := WdMain.StringGrid1.Cells[1, Fin] +
      ' ' + WdMain.StringGrid1.Cells[2, Fin];

    Gr1_Img1_Clear;
    PaLgDeb.Caption := IntToStr(Debut);
    PaLgFin.Caption := IntToStr(Fin);
    PaZ.Color := clCream;
    PaZ.Caption := '0';
    Erreurs := 0;
    //-
    Gr1_Traitement_des_donnees(Debut, Fin);
    //-
    Gr1_Regression_lineaire_Init(Debut, Fin);
    //-
    //Graphe affiche
    Gr1_Affichage(Debut, Fin);
    //-
    Gr1_Regression_lineaire_Affichage;
    //-
    ActiveControl := PaZ;
  end;
end;

procedure TWdGraphe.SpP20Click(Sender: TObject);
begin
  Dec(GrFin, 20);
  if GrFin < GrWinMax_ then
    GrFin := GrWinMax_;
  Gr1_Graphe_Affiche(GrFin);
end;

procedure TWdGraphe.SpM20Click(Sender: TObject);
begin
  Inc(GrFin, 20);
  if GrFin > WdMain.StringGrid1.RowCount - 1 then
    GrFin := WdMain.StringGrid1.RowCount - 1;
  Gr1_Graphe_Affiche(GrFin);
end;

procedure TWdGraphe.SpDebutClick(Sender: TObject);
begin
  GrFin := GrWinMax_;
  Gr1_Graphe_Affiche(GrFin);
end;

procedure TWdGraphe.SpFinClick(Sender: TObject);
begin
  GrFin := GrFin0;
  Gr1_Graphe_Affiche(GrFin);
end;

procedure TWdGraphe.SpP1Click(Sender: TObject);
begin
  Dec(GrFin);
  if GrFin < GrWinMax_ then
    GrFin := GrWinMax_;
  Gr1_Graphe_Affiche(GrFin);
end;

procedure TWdGraphe.SpM1Click(Sender: TObject);
begin
  Inc(GrFin);
  if GrFin > WdMain.StringGrid1.RowCount - 1 then
    GrFin := WdMain.StringGrid1.RowCount - 1;
  Gr1_Graphe_Affiche(GrFin);
end;

procedure TWdGraphe.SpeedButton8Click(Sender: TObject);
begin
  WdGraphe.Close;
end;

procedure TWdGraphe.SpeedButton1Click(Sender: TObject);
begin
  Gr1_Copie_Presse_Papier;
  ShowMessage('La fenêtre courante a été copiée dans le presse-papier.');
end;

procedure TWdGraphe.ImgMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
var
  Xecr, Yecr: integer;
begin
  Xecr := X - GrDecalX_;
  Yecr := Round((Gr1MaxY - Y) / Gr1CoefY);
  if Xecr >= 0 then
  begin
    Xecr := GrFin - GrWinMax_ + (Xecr div 4) + 1;
    PaXY.Caption := IntToStr((Xecr)) + '/' + IntToStr(Yecr);
  end
  else
  begin
    PaXY.Caption := '-';
  end;
end;

procedure TWdGraphe.CkL1Change(Sender: TObject);
begin
  Gr1_Graphe_Affiche(GrFin);
end;

procedure TWdGraphe.FormShow(Sender: TObject);
begin
  WdGraphe.Width := 808;
  WdGraphe.Height := 708;
  ActiveControl := PaZ;
  Pat.Enabled := False;
  //Max
  Gr1MaxX := Img.Width - 1;
  Gr1MaxY := Img.Height - 1;
  Gr1CoefY := (Gr1MaxY + 1) / Axes1MaxY_;
  //Debut
  GrFin0 := WdMain.StringGrid1.Row;
  GrFin := GrFin0;
  //Curseur de bas de page
  PaCurseur.Left := Round(0.2 * GrFin);
  //-
  Gr1_Graphe_Affiche(GrFin);
  //-
  ActiveControl := PaZ;
  Pat.Enabled := True;
end;

end.
