unit mimapulse_graphe3;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Buttons,
  //Copie écran
  ClipBrd, //ClipBoard
  LCLIntf, //GetDC
  LCLType; //HDC

type

  { TWdGraphe3 }

  TWdGraphe3 = class(TForm)
    CkL3: TCheckBox;
    EdDeb: TEdit;
    EdFin: TEdit;
    GrMaxi: TGroupBox;
    GrMini: TGroupBox;
    GrPulse: TGroupBox;
    ImgMaxi: TImage;
    ImgMini: TImage;
    ImgPulse: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    LaDeb: TLabel;
    LaFin: TLabel;
    Pa1: TPanel;
    PaMaxi: TPanel;
    PaMini: TPanel;
    PaLgDeb: TPanel;
    PaCurseur: TPanel;
    PaLgFin: TPanel;
    PaEvMax: TPanel;
    PaEvMin: TPanel;
    PaEvPulse: TPanel;
    PaPos: TPanel;
    PaT: TPanel;
    PaZ: TPanel;
    PaXY: TPanel;
    PaPulse: TPanel;
    SpDebut: TSpeedButton;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpFin: TSpeedButton;
    SpM1: TSpeedButton;
    SpM20: TSpeedButton;
    SpP1: TSpeedButton;
    SpP20: TSpeedButton;
    procedure CkL3Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ImgMaxiMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
    procedure ImgMiniMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
    procedure ImgPulseMouseMove(Sender: TObject; Shift: TShiftState; X, Y: integer);
    procedure SpDebutClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpFinClick(Sender: TObject);
    procedure SpP1Click(Sender: TObject);
    procedure SpP20Click(Sender: TObject);
    procedure SpM1Click(Sender: TObject);
    procedure SpM20Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  WdGraphe3: TWdGraphe3;

implementation

uses mimapulse_main;

{$R *.lfm}

{ TWdGraphe3 }

var
  Gr3CoefMaxiY: real;
  Gr3CoefMiniY: real;
  Gr3CoefPulseY: real;
  Gr3MaxiX, Gr3MaxiY: integer;
  Gr3MiniX, Gr3MiniY: integer;
  Gr3PulseX, Gr3PulseY: integer;
  GrFin0, GrFin: integer;
  //Moindres carrés
  Mc3Ydeb, Mc3Yfin: array[1..3] of integer;

procedure Gr3_Copie_Presse_Papier;
var
  Bitmap: TBitmap;
  ScreenDC: HDC;
begin
  with WdGraphe3 do
  begin
    //Copie vers Clipboard
    try
      Bitmap := TBitmap.Create;
      //Récupère le handle de la feuille
      ScreenDC := GetDC(handle);
      Bitmap.LoadFromDevice(ScreenDC);
      ReleaseDC(handle, ScreenDC);
      //Envoyer dans le Clipboard
      ClipBoard.Assign(Bitmap);
    finally
      Bitmap.Free;
    end;
  end;
end;

procedure Gr3_Img_Clear;
const
  DeltaY_ = 20;
  DeltaN_ = 10;
var
  n, x, y: integer;
begin
  with WdGraphe3 do
  begin
    //----- Maxima -----
    with ImgMaxi.Canvas do
    begin
      //Clean Maxi
      Pen.Color := ClCream;
      for x := 0 to Gr3MaxiX do
        Line(x, 0, x, Gr3MaxiY);
      //Affichage des axes
      n := 80;
      y := Gr3MaxiY;
      repeat
        if (n > 80) and (n < 170) then
        begin
          Pen.Color := ClSilver;
          Line(GrDecalX_, y, Gr3MaxiX - GrDecalX_, y);
          TextOut(3, y - 8, IntToStr(n));
          TextOut(Gr3MaxiX - GrDecalX_, y - 8, IntToStr(n));
          if n = 130 then
          begin
            Pen.Color := ClBlue;
            Line(GrDecalX_, y, Gr3MaxiX - GrDecalX_, y);
          end;
        end;
        Dec(y, DeltaY_);
        Inc(n, DeltaN_);
      until y < 0;
    end;
    //----- Minima -----
    with ImgMini.Canvas do
    begin
      //Clean Mini
      Pen.Color := ClCream;
      for x := 0 to Gr3MiniX do
        Line(x, 0, x, Gr3MiniY);
      //Affichage des axes
      n := 30;
      y := Gr3MiniY;
      repeat
        if (n > 40) and (n < 120) then
        begin
          Pen.Color := ClSilver;
          Line(GrDecalX_, y, Gr3MiniX - GrDecalX_, y);
          case n of
            50..90: TextOut(11, y - 8, IntToStr(n));
            100..110: TextOut(3, y - 8, IntToStr(n));
          end;
          TextOut(Gr3MaxiX - GrDecalX_, y - 8, IntToStr(n));
          if n = 80 then
          begin
            Pen.Color := ClBlue;
            Line(GrDecalX_, y, Gr3MaxiX - GrDecalX_, y);
          end;
        end;
        Dec(y, DeltaY_);
        Inc(n, DeltaN_);
      until y < 0;
    end;
    //----- Pulsations -----
    with ImgPulse.Canvas do
    begin
      //Clean Pulse
      Pen.Color := ClCream;
      for x := 0 to Gr3PulseX do
        Line(x, 0, x, Gr3PulseY);
      //Affichage des axes
      n := 30;
      y := Gr3MaxiY;
      repeat
        if (n > 30) and (n < 130) then
        begin
          Pen.Color := ClSilver;
          Line(GrDecalX_, y, Gr3PulseX - GrDecalX_, y);
          case n of
            40..90: TextOut(11, y - 8, IntToStr(n));
            100..120: TextOut(3, y - 8, IntToStr(n));
          end;
          if n = 60 then
          begin
            Pen.Color := ClBlue;
            Line(GrDecalX_, y, Gr3PulseX - GrDecalX_, y);
          end;
          TextOut(Gr3PulseX - GrDecalX_, y - 8, IntToStr(n));
        end;
        Dec(y, DeltaY_);
        Inc(n, DeltaN_);
      until y < 0;
    end;
  end;
end;

procedure Gr3_Graphe_Affiche(GrFin: integer);
var
  //Tableau des données pour traitement
  //Maxima, Minima, Pulsations, Ecarts
  Gr3XY: array[1..GrWinMax_, 1..4] of integer;
  //Ecarts
  Gr3EcCol: array[1..GrWinMax_] of TColor;
  //Champs vides
  Erreurs: integer;

  function EcartCol(Ec: integer): TColor;
  var
    Col: TColor;
  begin
    if Ec > 0 then
    begin
      if Ec > 50 then
      begin
        Col := $000080FF;
      end
      else
      begin
        if Ec < 40 then
          Col := clAqua
        else
          Col := clBlue;
      end;
    end
    else
    begin
      Col := ClTeal;
    end;
    Result := Col;
  end;

  function ConvertEcran(Select, y: integer): integer;
  begin
    case Select of
      1: Result := Gr3MaxiY - Round(y * Gr3CoefMaxiY) + 160;
      2: Result := Gr3MiniY - Round(y * Gr3CoefMiniY) + 60;
      3: Result := Gr3PulseY - Round(y * Gr3CoefPulseY) + 60;
    end;
  end;

  procedure Gr3_Traitement_des_donnees(Debut, Fin: integer);
  var
    n, y: integer;
  begin
    with WdGraphe3 do
    begin
      n := 1;
      for y := Debut to Fin do
      begin
        //Maxima
        Gr3XY[n, 1] := WdMain.Convert(WdMain.StringGrid1.Cells[3, y]);
        //Minima
        Gr3XY[n, 2] := WdMain.Convert(WdMain.StringGrid1.Cells[4, y]);
        //Pulsations
        Gr3XY[n, 3] := WdMain.Convert(WdMain.StringGrid1.Cells[5, y]);
        //Ecarts
        Gr3XY[n, 4] := Gr3XY[n, 1] - Gr3XY[n, 2];
        Inc(n);
      end;
      //Traitement pour affichage
      for n := 1 to GrWinMax_ do
      begin
        //Maxima
        if Gr3XY[n, 1] > 0 then
        begin
          Gr3XY[n, 1] := ConvertEcran(1, Gr3XY[n, 1]);
        end
        else
        begin
          Gr3XY[n, 1] := ConvertEcran(1, GrMoyMaxi_);
          Inc(Erreurs);
        end;
        //Minima
        if Gr3XY[n, 2] > 0 then
        begin
          Gr3XY[n, 2] := ConvertEcran(2, Gr3XY[n, 2]);
        end
        else
        begin
          Gr3XY[n, 2] := ConvertEcran(2, GrMoyMini_);
          Inc(Erreurs);
        end;
        //Pulsations
        if Gr3XY[n, 3] > 0 then
        begin
          Gr3XY[n, 3] := ConvertEcran(3, Gr3XY[n, 3]);
        end
        else
        begin
          Gr3XY[n, 3] := ConvertEcran(3, GrMoyPulse_);
          Inc(Erreurs);
        end;
        //Ecarts
        Gr3EcCol[n] := EcartCol(Gr3XY[n, 4]);
        if Gr3XY[n, 4] > 0 then
          Gr3XY[n, 4] := Gr3MiniY - Round(Gr3XY[n, 4] * 0.8);
      end;
      //Erreurs
      if Erreurs > 0 then
      begin
        PaZ.Color := $008888FF;
        PaZ.Font.Color := ClBlack;
        PaZ.Caption := IntToStr(Erreurs);
      end
      else
      begin
        PaZ.Color := $00C4FFC4;
        PaZ.Font.Color := ClBlue;
        PaZ.Caption := '0';
      end;
    end;
  end;

  procedure Gr3_Affichage(Debut, Fin: integer);
  var
    Gr3XYMem: integer;
    n, x, y1, y2: integer;
    Les, LesMem: integer;
  begin
    with WdGraphe3 do
    begin
      PaCurseur.Left := Round(0.2 * Fin) - 36;
      PaLgDeb.Caption := IntToStr(Debut);
      PaLgFin.Caption := IntToStr(Fin);
      with ImgMaxi.Canvas do
      begin
        //----- Maxima -----
        //Mem début
        Gr3XYMem := Gr3XY[1, 1];
        LesMem := WdMain.LES_3(Alpha_, Gr3XY[4, 1], Gr3XY[3, 1], Gr3XY[2, 1], Gr3XY[1, 1]);
        //-
        x := 5;
        for n := 2 to GrWinMax_ do
        begin
          if CkL3.Checked then
            Pen.Color := ClSilver
          else
            Pen.Color := ClBlack;
          //Graphe
          y2 := Gr3XY[n, 1];
          Line(GrDecalX_ + x - 4, Gr3XYMem, GrDecalX_ + x, y2);
          Gr3XYMem := y2;
          //Lissage
          if CkL3.Checked then
          begin
            if n > 3 then
            begin
              Pen.Color := ClBlack;
              Les := WdMain.LES_3(Alpha_, y2, Gr3XY[n - 1, 1], Gr3XY[n - 2, 1], Gr3XY[n - 3, 1]);
              Line(GrDecalX_ + x - 4, LesMem + 50, GrDecalX_ + x, Les + 50);
              Line(GrDecalX_ + x - 4, LesMem + 51, GrDecalX_ + x, Les + 51);
              LesMem := Les;
            end;
          end;
          Inc(x, 4);
        end;
      end;
      with ImgMini.Canvas do
      begin
        //----- Minima -----
        Gr3XYMem := Gr3XY[1, 2];
        x := 5;
        for n := 2 to GrWinMax_ do
        begin
          if CkL3.Checked then
            Pen.Color := ClSilver
          else
            Pen.Color := ClBlack;
          //Graphe
          y2 := Gr3XY[n, 2];
          Line(GrDecalX_ + x - 4, Gr3XYMem, GrDecalX_ + x, y2);
          Gr3XYMem := y2;
          //-
          if CkL3.Checked then
          begin
            if n > 3 then
            begin
              Pen.Color := ClBlack;
              Les := WdMain.LES_3(Alpha_, y2, Gr3XY[n - 1, 2], Gr3XY[n - 2, 2], Gr3XY[n - 3, 2]);
              Line(GrDecalX_ + x - 4, LesMem + 50, GrDecalX_ + x, Les + 50);
              Line(GrDecalX_ + x - 4, LesMem + 51, GrDecalX_ + x, Les + 51);
              LesMem := Les;
            end;
          end;
          Inc(x, 4);
        end;
        //----- Ecarts -----
        x := 1;
        y1 := Round(95 * Gr3CoefMiniY);
        for n := 1 to GrWinMax_ do
        begin
          //Graphe
          Pen.Color := Gr3EcCol[n];
          if Gr3XY[n, 4] > 0 then
            Line(GrDecalX_ + x, y1, GrDecalX_ + x, Gr3XY[n, 4])
          else
            Pixels[GrDecalX_ + x, y1] := ClTeal;
          Inc(x, 4);
        end;
      end;
      with ImgPulse.Canvas do
      begin
        //----- Pulsations -----
        Gr3XYMem := Gr3XY[1, 3];
        x := 5;
        for n := 2 to GrWinMax_ do
        begin
          if CkL3.Checked then
            Pen.Color := ClSilver
          else
            Pen.Color := ClBlack;
          //Graphe
          y2 := Gr3XY[n, 3];
          Line(GrDecalX_ + x - 4, Gr3XYMem, GrDecalX_ + x, y2);
          Gr3XYMem := y2;
          //-
          if CkL3.Checked then
          begin
            if n > 3 then
            begin
              Pen.Color := ClBlack;
              Les := WdMain.LES_3(Alpha_, y2, Gr3XY[n - 1, 3], Gr3XY[n - 2, 3], Gr3XY[n - 3, 3]);
              Line(GrDecalX_ + x - 4, LesMem + 67, GrDecalX_ + x, Les + 67);
              Line(GrDecalX_ + x - 4, LesMem + 68, GrDecalX_ + x, Les + 68);
              LesMem := Les;
            end;
          end;
          Inc(x, 4);
        end;
      end;
    end;
  end;

  procedure Gr3_Regression_lineaire_Init(Debut, Fin: integer);
  var
    a, b: real;
    n: integer;
  begin
    //----- Régression linéaire par la méthode des moindres carrés -----
    for n := 1 to 3 do
    begin
      a := 0;
      b := 0;
      Mc3Ydeb[n] := 0;
      Mc3Yfin[n] := 0;
      WdMain.Moindres_carres(n, Debut, Fin, a, b, Mc3Ydeb[n], Mc3Yfin[n]);
      //Y : Début, Fin
      Mc3Ydeb[n] := Round((a * Mc3Ydeb[n]) + b);
      Mc3Yfin[n] := Round((a * Mc3Yfin[n]) + b);
    end;
  end;

  procedure Gr3_Regression_lineaire_Affichage;
  var
    n, Yd, Yf: integer;
  begin
    with WdGraphe3 do
    begin
      //Maxima
      with ImgMaxi.Canvas do
      begin
        Pen.Color := ClFuchsia;
        n := 1;
        if Mc3Yfin[n] > 0 then
        begin
          Yd := ConvertEcran(1, Mc3Ydeb[n]);
          Yf := ConvertEcran(1, Mc3Yfin[n]);
          Line(GrDecalX_, Yd, Gr3MaxiX - GrDecalX_, Yf);
          Line(GrDecalX_, Yd + 1, Gr3MaxiX - GrDecalX_, Yf + 1);
          PaEvMax.Caption := IntToStr(Mc3Yfin[n]);
        end
        else
        begin
          PaEvMax.Caption := '';
        end;
      end;
      //Minima
      with ImgMini.Canvas do
      begin
        Pen.Color := ClFuchsia;
        n := 2;
        if Mc3Yfin[n] > 0 then
        begin
          //Début, Fin
          Yd := ConvertEcran(n, Mc3Ydeb[n]);
          Yf := ConvertEcran(n, Mc3Yfin[n]);
          //Affichage
          Line(GrDecalX_, Yd, Gr3MaxiX - GrDecalX_, Yf);
          Line(GrDecalX_, Yd + 1, Gr3MaxiX - GrDecalX_, Yf + 1);
          PaEvMin.Caption := IntToStr(Mc3Yfin[n]);
        end
        else
        begin
          PaEvMin.Caption := '';
        end;
      end;
      //Pulsation
      with ImgPulse.Canvas do
      begin
        Pen.Color := ClFuchsia;
        n := 3;
        if Mc3Yfin[n] > 0 then
        begin
          //Début
          Yd := ConvertEcran(n, Mc3Ydeb[n]);
          //Fin
          Yf := ConvertEcran(n, Mc3Yfin[n]);
          //Affichage
          Line(GrDecalX_, Yd, Gr3MaxiX - GrDecalX_, Yf);
          Line(GrDecalX_, Yd + 1, Gr3MaxiX - GrDecalX_, Yf + 1);
          PaEvPulse.Caption := IntToStr(Mc3Yfin[n]);
        end
        else
        begin
          PaEvPulse.Caption := '';
        end;
      end;
    end;
  end;

var
  DebutGraphe: integer;
  FinGraphe: integer;
begin
  with WdGraphe3 do
  begin
    FinGraphe := GrFin;
    if FinGraphe < GrWinMax_ then
      FinGraphe := GrWinMax_;
    DebutGraphe := FinGraphe - GrWinMax_ + 1;
    if DebutGraphe < 1 then
      DebutGraphe := 1;
    //-
    EdDeb.Text := WdMain.StringGrid1.Cells[1, DebutGraphe] +
      ' ' + WdMain.StringGrid1.Cells[2, DebutGraphe];
    EdFin.Text := WdMain.StringGrid1.Cells[1, FinGraphe] +
      ' ' + WdMain.StringGrid1.Cells[2, FinGraphe];
    //-
    Gr3_Img_Clear;
    PaLgDeb.Caption := IntToStr(FinGraphe);
    PaZ.Color := clCream;
    PaZ.Caption := '0';
    Erreurs := 0;
    //-
    Gr3_Regression_lineaire_Init(DebutGraphe, FinGraphe);
    //-
    Gr3_Traitement_des_donnees(DebutGraphe, FinGraphe);
    //-
    Gr3_Affichage(DebutGraphe, FinGraphe);
    //-
    Gr3_Regression_lineaire_Affichage;
    //-
  end;
end;

procedure TWdGraphe3.SpDebutClick(Sender: TObject);
begin
  GrFin := GrWinMax_;
  Gr3_Graphe_Affiche(GrFin);
end;

procedure TWdGraphe3.SpeedButton1Click(Sender: TObject);
begin
  Gr3_Copie_Presse_Papier;
  ShowMessage('La fenêtre courante a été copiée dans le presse-papier.');
end;

procedure TWdGraphe3.SpeedButton2Click(Sender: TObject);
begin
  WdGraphe3.Close;
end;

procedure TWdGraphe3.SpFinClick(Sender: TObject);
begin
  GrFin := GrFin0;
  Gr3_Graphe_Affiche(GrFin);
end;

procedure TWdGraphe3.SpP1Click(Sender: TObject);
begin
  Inc(GrFin);
  if GrFin > WdMain.StringGrid1.RowCount - 1 then
    GrFin := WdMain.StringGrid1.RowCount - 1;
  Gr3_Graphe_Affiche(GrFin);
end;

procedure TWdGraphe3.SpP20Click(Sender: TObject);
begin
  Inc(GrFin, 20);
  if GrFin > WdMain.StringGrid1.RowCount - 1 then
    GrFin := WdMain.StringGrid1.RowCount - 1;
  Gr3_Graphe_Affiche(GrFin);
end;

procedure TWdGraphe3.SpM1Click(Sender: TObject);
begin
  Dec(GrFin);
  if GrFin < GrWinMax_ then
    GrFin := GrWinMax_;
  Gr3_Graphe_Affiche(GrFin);
end;

procedure TWdGraphe3.SpM20Click(Sender: TObject);
begin
  Dec(GrFin, 20);
  if GrFin < GrWinMax_ then
    GrFin := GrWinMax_;
  Gr3_Graphe_Affiche(GrFin);
end;

procedure TWdGraphe3.ImgMaxiMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: integer);
var
  Xecr, Yecr: integer;
begin
  Xecr := X - GrDecalX_;
  Yecr := Round((Gr3MaxiY - Y + 160) / 2);
  if Xecr >= 0 then
  begin
    Xecr := GrFin - GrWinMax_ + (Xecr div 4) + 1;
    PaXY.Caption := IntToStr((Xecr)) + '/' + IntToStr(Yecr);
  end
  else
  begin
    PaXY.Caption := '-';
  end;
end;

procedure TWdGraphe3.ImgMiniMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: integer);
var
  Xecr, Yecr: integer;
begin
  Xecr := X - GrDecalX_;
  Yecr := Round((Gr3MiniY - Y + 60) / 2);
  if Xecr >= 0 then
  begin
    Xecr := GrFin - GrWinMax_ + (Xecr div 4) + 1;
    PaXY.Caption := IntToStr((Xecr)) + '/' + IntToStr(Yecr);
  end
  else
  begin
    PaXY.Caption := '-';
  end;
end;


procedure TWdGraphe3.ImgPulseMouseMove(Sender: TObject; Shift: TShiftState;
  X, Y: integer);
var
  Xecr, Yecr: integer;
begin
  Xecr := X - GrDecalX_;
  Yecr := Round((Gr3PulseY - Y + 60) / 2);
  if Xecr >= 0 then
  begin
    Xecr := GrFin - GrWinMax_ + (Xecr div 4) + 1;
    PaXY.Caption := IntToStr((Xecr)) + '/' + IntToStr(Yecr);
  end
  else
  begin
    PaXY.Caption := '-';
  end;
end;

procedure TWdGraphe3.FormShow(Sender: TObject);
begin
  with WdGraphe3 do
  begin
    //Maxi
    Gr3MaxiX := ImgMaxi.Width - 1;
    Gr3MaxiY := ImgMaxi.Height - 1;
    Gr3CoefMaxiY := 2;
    //Mini
    Gr3MiniX := ImgMini.Width - 1;
    Gr3MiniY := ImgMini.Height - 1;
    Gr3CoefMiniY := 2;
    //Pulse
    Gr3PulseX := ImgPulse.Width - 1;
    Gr3PulseY := ImgPulse.Height - 1;
    Gr3CoefPulseY := 2;
    //Debut
    GrFin0 := WdMain.StringGrid1.Row;
    GrFin := GrFin0;
    //Curseur de bas de page
    PaCurseur.Left := Round(0.2 * GrFin);
    //-
    Gr3_Graphe_Affiche(GrFin);
    //-
    ActiveControl := PaZ;
    Pat.Enabled := True;
  end;
end;

procedure TWdGraphe3.CkL3Change(Sender: TObject);
begin
  Gr3_Graphe_Affiche(GrFin);
end;

end.
