unit mimapulse_main;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, Menus,
  ExtCtrls, StdCtrls, Buttons, Grids,
  iniFiles, Types,
  Math,
  //Copie écran
  ClipBrd, //ClipBoard
  LCLIntf, //GetDC
  LCLType; //HDC

const
  Version_ = ' Mini, Maxi, Pulse - v1.8.6 by Didier GERARD';
  //Couleurs
  ColVert_ = $008CFF8C;
  ColBleu_ = $00FFCACA;
  ColJaune_ = $008AFFFF;
  ColOrange_ = $000080FF;
  ColRouge_ = $007D7DFF;
  ColRose_ = $00FFB0FF;
  ColAig_ = $00F480C9;
  //Col_Gris_ = $00B0B0B0;
  //Ini
  IniNom_ = 'MiMaPulse.ini';
  //CSV
  CSVNom_ = 'Mimapulse.csv';
  //Produits
  ProduitsNom_ = 'Mimapulse.prd';
  ProduitsMax_ = 10;
  //Data
  DataMax_ = 4000;
  //Data
  DataNom_ = 'MiMaPulse.dat';
  DataMaxX_ = 15;
  //Graphe
  GrWinMax_ = 186;
  GrDecalX_ = 20;
  GrMoyMaxi_ = 120;
  GrMoyMini_ = 80;
  GrMoyPulse_ = 60;
  //Regession polynomiale
  MaxSC_ = 12;
  //Lissage Exponentile Simple
  Alpha_ = 0.15;

type
  S003_ = string

    [3];
  S010_ = string

    [10];
  S030_ = string

    [30];
  S040_ = string

    [40];
  //Produits
  Produits_ = array[1..ProduitsMax_] of S030_;

  Dta_ = record
    i, j: integer;
    k: string[10];
  end;
  //Data
  DataOld_ = record
    DateS: S010_;
    HeureS: S010_;
    Maxi: S003_;
    Mini: S003_;
    Pulse: S003_;
    Produit: S040_;
  end;
  Data_ = array[1..DataMax_] of record
    DateS: S010_;
    HeureS: S010_;
    Maxi: S003_;
    Mini: S003_;
    Pulse: S003_;
    Produits: Produits_;
  end;

  { TWdMain }

  TWdMain = class(TForm)
    ChDTreel: TCheckBox;
    EdDate: TEdit;
    EdHeures: TEdit;
    EdProduit2: TEdit;
    EdMinutes: TEdit;
    EdSecondes: TEdit;
    EdProduit1: TEdit;
    EdMaxi: TEdit;
    EdMini: TEdit;
    EdPulse: TEdit;
    EdDelta: TEdit;
    GrbPad: TGroupBox;
    Img1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    LaDelta: TLabel;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem10: TMenuItem;
    MenuItem11: TMenuItem;
    MenuItem12: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    MenuItem6: TMenuItem;
    MenuItem7: TMenuItem;
    MenuItem8: TMenuItem;
    MenuItem9: TMenuItem;
    OpenDialog1: TOpenDialog;
    Pa0: TPanel;
    Pa1: TPanel;
    Pa2: TPanel;
    Pa3: TPanel;
    PaHr: TPanel;
    PaMaxi0: TPanel;
    Pa4: TPanel;
    PaPad: TPanel;
    PaPad3: TPanel;
    PaPad0: TPanel;
    PaPadDel: TPanel;
    PaPadV: TPanel;
    PaPad7: TPanel;
    PaPad8: TPanel;
    PaPad9: TPanel;
    PaPad4: TPanel;
    PaPad5: TPanel;
    PaPad6: TPanel;
    PaPad1: TPanel;
    PaPad2: TPanel;
    PaMini0: TPanel;
    PaPulse0: TPanel;
    PaY: TPanel;
    SpeedButton1: TSpeedButton;
    SpeedButton2: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpVal: TSpeedButton;
    SpSauve: TSpeedButton;
    SpdEffLigne: TSpeedButton;
    SpFin: TSpeedButton;
    SpDebut: TSpeedButton;
    SpHaut: TSpeedButton;
    SpBas: TSpeedButton;
    StringGrid1: TStringGrid;
    Timer1: TTimer;
    Timer2: TTimer;
    procedure ChDTreelChange(Sender: TObject);
    procedure EdMaxiChange(Sender: TObject);
    procedure EdMaxiClick(Sender: TObject);
    procedure EdMaxiKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
    procedure EdMiniChange(Sender: TObject);
    procedure EdMiniClick(Sender: TObject);
    procedure EdMiniKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
    procedure EdProduit1Click(Sender: TObject);
    procedure EdProduit2Click(Sender: TObject);
    procedure EdPulseClick(Sender: TObject);
    procedure EdPulseKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormShow(Sender: TObject);
    procedure MenuItem10Click(Sender: TObject);
    procedure MenuItem11Click(Sender: TObject);
    procedure MenuItem12Click(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem4Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
    procedure MenuItem6Click(Sender: TObject);
    procedure MenuItem7Click(Sender: TObject);
    procedure MenuItem9Click(Sender: TObject);
    procedure Pa1Click(Sender: TObject);
    procedure PaPad0Click(Sender: TObject);
    procedure PaPad1Click(Sender: TObject);
    procedure PaPad2Click(Sender: TObject);
    procedure PaPad3Click(Sender: TObject);
    procedure PaPad4Click(Sender: TObject);
    procedure PaPad5Click(Sender: TObject);
    procedure PaPad6Click(Sender: TObject);
    procedure PaPad7Click(Sender: TObject);
    procedure PaPad8Click(Sender: TObject);
    procedure PaPad9Click(Sender: TObject);
    procedure PaPadDelClick(Sender: TObject);
    procedure PaPadVClick(Sender: TObject);
    procedure PaPulse0Click(Sender: TObject);
    procedure SpdEffLigneClick(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure SpeedButton2Click(Sender: TObject);
    procedure SpeedButton3Click(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
    procedure SpSauveClick(Sender: TObject);
    procedure SpFinClick(Sender: TObject);
    procedure SpDebutClick(Sender: TObject);
    procedure SpHautClick(Sender: TObject);
    procedure SpBasClick(Sender: TObject);
    procedure SpValClick(Sender: TObject);
    procedure StringGrid1Click(Sender: TObject);
    procedure StringGrid1MouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: integer; MousePos: TPoint; var Handled: boolean);
    procedure Timer1Timer(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
    DirExe: string;
    //Data
    DataFile: string;
    Data: Data_;
    //Coefficients polynomiaux cherchés
    SCa: array[0..MaxSC_ + 1] of double;
    //Fonctions
    function If_Chiffre0_9(s: string): boolean;
    function Convert(s: string): integer;
    //Lissage Exponentiel Simple
    function LES_3(a: real; v0, v1, v2, v3: integer): integer;
    //Procédures
    procedure Copie_Presse_Papier;
    procedure Moindres_Carres(var Data2: Data_; Select, MaxDeb, MaxFin: integer; var a, b: real);
    procedure Moindres_carres(Select, Debut, Fin: integer; var a, b: real;
      var Ydebut, Yfin: integer);
    //procedure Systeme_de_Cramer(Debut:integer);
    //procedure B_Spline_Equation(X1, Y1, X2, Y2, X3, Y3, X4, Y4: integer; t: real;
    //  var Xout, Yout: integer);
  end;

var
  WdMain: TWdMain;
//Graphe:Tableau de la fenêtre graphique
//GrTab:array[1..GrTabMax_,1..3] of integer;

implementation

uses mimapulse_produits, mimapulse_graphe, mimapulse_graphe3, mimapulse_aide;

{$R *.lfm}

{ TWdMain }

var
  DataOld: DataOld_;
  //Time
  Minutes: array[0..59, 1..2] of real;
  Heu: array[0..59, 1..4, 1..2] of real;
  Min: array[0..59, 1..6, 1..2] of real;
  Sec: array[0..59, 1..8, 1..2] of real;
  Heure, Minute: word;
  Seconde, MilliSec: word;
  MemHeu, MemMin, MemSec: word;
  //-
  Select: integer;

function Key_Convert(Key: word): string;
var
  s: string;
begin
  s := '';
  case Key of
    96: s := '0';
    97: s := '1';
    98: s := '2';
    99: s := '3';
    100: s := '4';
    101: s := '5';
    102: s := '6';
    103: s := '7';
    104: s := '8';
    105: s := '9';
  end;
  Result := s;
end;

function TWdMain.If_Chiffre0_9(s: string): boolean;
var
  Chiffres: integer;
  n: integer;
  Ok: boolean;
begin
  Ok := False;
  if Length(s) > 0 then
  begin
    Chiffres := 0;
    for n := 1 to Length(s) do
      if s[n] in ['0'..'9'] then
        Inc(Chiffres);
    if Chiffres = Length(s) then
      Ok := True;
  end;
  Result := Ok;
end;

function TWdMain.Convert(s: string): integer;
var
  v: integer;
begin
  if s = '' then
    s := '0';
  if WdMain.If_Chiffre0_9(s) then
    v := StrToInt(s)
  else
    v := 0;
  Result := v;
end;

function Derniere_Ligne(Debut: integer): integer;
var
  Dl, n, x, y: integer;
begin
  with WdMain do
  begin
    Dl := 0;
    y := Debut;
    if y > StringGrid1.RowCount - 1 then
      y := 1;
    repeat
      //Test ligne
      n := 0;
      for x := 1 to DataMaxX_ do
        if StringGrid1.Cells[x, y] = '' then
          Inc(n);
      //Ligne vide
      if n = DataMaxX_ then
        Dl := y
      else
        Inc(y);
    until (Dl > 0) or (y > DataMax_);
    Dec(y);
    if y < 1 then
      y := 1;
  end;
  Result := y;
end;

function Champ_Vide: integer;
var
  Mem, Tr, y: integer;
  Ok: boolean;
begin
  with WdMain do
  begin
    Mem := StringGrid1.Row;
    y := Mem + 1;
    if y > StringGrid1.RowCount - 1 then
      y := 1;
    Tr := 0;
    Ok := False;
    repeat
      //Test ligne
      with StringGrid1 do
      begin
        if (Cells[3, y] = '') or (Cells[4, y] = '') or
          (Cells[5, y] = '') then
          Ok := True;
      end;
      if not Ok then
      begin
        Inc(y);
        if y > StringGrid1.RowCount - 1 then
        begin
          y := 1;
          Inc(Tr);
        end;
      end;
    until (Ok) or (Tr > 1);
  end;
  if Ok then
    Result := y
  else
    Result := Mem;
end;

procedure Version;
begin
  WdMain.Caption := Version_ + '    -    ' + ExtractFileName(WdMain.DataFile);
end;

procedure TWdMain.Copie_Presse_Papier;
var
  Bitmap: TBitmap;
  ScreenDC: HDC;
begin
  with WdMain do
  begin
    //Copie vers Clipboard
    try
      Bitmap := TBitmap.Create;
      //Récupère le handle de la feuille
      ScreenDC := GetDC(handle);
      Bitmap.LoadFromDevice(ScreenDC);
      ReleaseDC(handle, ScreenDC);
      //Envoyer dans le Clipboard
      ClipBoard.Assign(Bitmap);
    finally
      Bitmap.Free;
    end;
  end;
end;

//----- INIFILES -------------------------------
procedure Ini_Lire;
var
  FIni: TiniFile;
  Fichier: string;
begin
  with WdMain do
  begin
    DataFile := DirExe + DataNom_;
    //-
    Fichier := DirExe + IniNom_;
    if FileExists(Fichier) then
    begin
      FIni := TiniFile.Create(Fichier);
      //Data
      DataFile := FIni.ReadString('Data', 'Nom', '');
      WdAide.CkAide.Checked := FIni.ReadBool('Aide', 'Demarrage', True);
      if DataFile = '' then
        DataFile := DirExe + DataNom_;
      Version;
      Fini.Free;
    end;
  end;
end;

procedure Ini_Sauve;
var
  FIni: TiniFile;
begin
  with WdMain do
  begin
    FIni := TiniFile.Create(DirExe + IniNom_);
    //Data
    FIni.WriteString('Data', 'Nom', WdMain.DataFile);
    FIni.WriteBool('Aide', 'Demarrage', WdAide.CkAide.Checked);
    Fini.Free;
  end;
end;

procedure TWdMain.Moindres_Carres(var Data2: Data_; Select, MaxDeb, MaxFin: integer;
  var a, b: real);
const
  Tmax_ = 4;
var
  Solutions: array[1..DataMax_, 1..Tmax_] of real;
  Somme: array[1..Tmax_] of real;
  MoyX, MoyY, v: real;
  n, p: integer;
begin
  with WdMain do
  begin
    if (MaxDeb >= 1) and (MaxFin <= DataMax_) then
    begin
      //Cleat Solutions
      for n := MaxDeb to MaxFin do
        for p := 1 to Tmax_ do
          Solutions[n, p] := 0;
      //Clear Somme
      for n := 1 to Tmax_ do
        Somme[n] := 0;
      //Moyennes X
      MoyX := 0;
      for n := MaxDeb to MaxFin do
      begin
        //Les données ici sont x:1,2,3,4...
        MoyX := MoyX + (n - MaxDeb + 1);
      end;
      MoyX := MoyX / MaxFin - MaxDeb + 1;
      //Moyenne Y
      MoyY := 0;
      for n := MaxDeb to MaxFin do
      begin
        v := 0;
        case Select of
          1: if If_Chiffre0_9(Data2[n].Maxi) then
              v := StrToInt(Data2[n].Maxi);
          2: if If_Chiffre0_9(Data2[n].Mini) then
              v := StrToInt(Data2[n].Mini);
          3: if If_Chiffre0_9(Data2[n].Pulse) then
              v := StrToInt(Data2[n].pulse);
        end;
        MoyY := MoyY + v;
      end;
      MoyY := MoyY / MaxFin - MaxDeb + 1;
      //Xi-Xbarre
      for n := MaxDeb to MaxFin do
      begin
        //Les données ici sont x:1,2,3,4...
        Solutions[n, 1] := (n - MaxDeb + 1) - MoyX;
      end;
      //Yi-Ybarre
      for n := MaxDeb to MaxFin do
      begin
        v := 0;
        case Select of
          1: if If_Chiffre0_9(Data2[n].Maxi) then
              v := StrToInt(Data2[n].Maxi);
          2: if If_Chiffre0_9(Data2[n].Mini) then
              v := StrToInt(Data2[n].Mini);
          3: if If_Chiffre0_9(Data2[n].Pulse) then
              v := StrToInt(Data2[n].pulse);
        end;
        Solutions[n, 2] := v - MoyY;
      end;
      //(Xi-Xbarre)²
      for n := MaxDeb to MaxFin do
        Solutions[n, 3] := Sqr(Solutions[n, 1]);
      //(Xi-Xbarre)(Xi-Ybarre)
      for n := MaxDeb to MaxFin do
        Solutions[n, 4] := Abs(Solutions[n, 1] * Solutions[n, 2]);
      //Sommes
      for n := MaxDeb to MaxFin do
      begin
        //Les données ici sont x:1,2,3,4...
        Somme[1] := Somme[1] + n - MaxDeb + 1;
        //-
        v := 0;
        case Select of
          1: if If_Chiffre0_9(Data2[n].Maxi) then
              v := StrToInt(Data2[n].Maxi);
          2: if If_Chiffre0_9(Data2[n].Mini) then
              v := StrToInt(Data2[n].Mini);
          3: if If_Chiffre0_9(Data2[n].Pulse) then
              v := StrToInt(Data2[n].pulse);
        end;
        Somme[2] := Somme[2] + v;
        Somme[3] := Somme[3] + Solutions[n, 3];
        Somme[4] := Somme[4] + Solutions[n, 4];
      end;
      //a de ax+b
      a := Somme[4] / Somme[3];
      //b de ax+b
      b := MoyY - (a * MoyX);
      //Droite ax+b : 1er XY
      //Yin:=a*1+b;
      //Droite ax+b : 1er XY
      //Yout:=a*6+b;
    end;
  end;
end;

procedure Affiche_Cadran;
var
  n, x1, y1, x2, y2: integer;
begin
  with WdMain.Img1.Canvas do
  begin
    n := 0;
    repeat
      case n of
        0, 15, 30, 45:
        begin
          x1 := Round(Minutes[n, 1] - 8);
          y1 := Round(Minutes[n, 2] - 8);
          x2 := Round(Minutes[n, 1] + 8);
          y2 := Round(Minutes[n, 2] + 8);
          Brush.Color := ColOrange_;
          Rectangle(x1, y1, x2, y2);
        end;
        5, 10, 20, 25, 35, 40, 50, 55:
        begin
          x1 := Round(Minutes[n, 1] - 5);
          y1 := Round(Minutes[n, 2] - 5);
          x2 := Round(Minutes[n, 1] + 5);
          y2 := Round(Minutes[n, 2] + 5);
          Brush.Color := ColBleu_;
          Rectangle(x1, y1, x2, y2);
        end;
      end;
      Inc(n, 5)
    until n > 55;
  end;
end;

procedure Aff_Heures(h, m: integer; Col: TColor);
var
  He, n, x, y: integer;
begin
  with WdMain.Img1.Canvas do
  begin
    //Affiche centre
    Brush.Color := ClBlue;
    Rectangle(140, 140, 160, 160);
    //Affiche heure
    He := h;
    case h of
      0, 12: case m of
          0..11: He := 0;
          12..23: He := 1;
          24..35: He := 2;
          36..47: He := 3;
          48..59: He := 4;
        end;
      1, 13: case m of
          0..11: He := 5;
          12..23: He := 6;
          24..35: He := 7;
          36..47: He := 8;
          48..59: He := 9;
        end;
      2, 14: case m of
          0..11: He := 10;
          12..23: He := 11;
          24..35: He := 12;
          36..47: He := 13;
          48..59: He := 14;
        end;
      3, 15: case m of
          0..11: He := 15;
          12..23: He := 16;
          24..35: He := 17;
          36..47: He := 18;
          48..59: He := 19;
        end;
      4, 16: case m of
          0..11: He := 20;
          12..23: He := 21;
          24..35: He := 22;
          36..47: He := 23;
          48..59: He := 24;
        end;
      5, 17: case m of
          0..11: He := 25;
          12..23: He := 26;
          24..35: He := 27;
          36..47: He := 28;
          48..59: He := 29;
        end;
      6, 18: case m of
          0..11: He := 30;
          12..23: He := 31;
          24..35: He := 32;
          36..47: He := 33;
          48..59: He := 34;
        end;
      7, 19: case m of
          0..11: He := 35;
          12..23: He := 36;
          24..35: He := 37;
          36..47: He := 38;
          48..59: He := 39;
        end;
      8, 20: case m of
          0..11: He := 40;
          12..23: He := 41;
          24..35: He := 42;
          36..47: He := 43;
          48..59: He := 44;
        end;
      9, 21: case m of
          0..11: He := 45;
          12..23: He := 46;
          24..35: He := 47;
          36..47: He := 48;
          48..59: He := 49;
        end;
      10, 22: case m of
          0..11: He := 50;
          12..23: He := 51;
          24..35: He := 52;
          36..47: He := 53;
          48..59: He := 54;
        end;
      11, 23: case m of
          0..11: He := 55;
          12..23: He := 56;
          24..35: He := 57;
          36..47: He := 58;
          48..59: He := 59;
        end;
    end;
    for n := 1 to 4 do
    begin
      Brush.Color := Col;
      x := Round(Heu[He, n, 1]);
      y := Round(Heu[He, n, 2]);
      Rectangle(x - 6, y - 6, x + 6, y + 6);
    end;
  end;
end;

procedure Aff_Minutes(m: integer; Col: TColor);
var
  n, x, y: integer;
begin
  with WdMain.Img1.Canvas do
  begin
    for n := 1 to 6 do
    begin
      Brush.Color := Col;
      x := Round(Min[m, n, 1]);
      y := Round(Min[m, n, 2]);
      Rectangle(x - 6, y - 6, x + 6, y + 6);
    end;
  end;
end;

procedure Aff_Secondes(s: integer; Col1, Col2: TColor);
var
  n, x, y: integer;
begin
  with WdMain.Img1.Canvas do
  begin
    for n := 1 to 8 do
    begin
      Brush.Color := Col1;
      x := Round(Sec[s, n, 1]);
      y := Round(Sec[s, n, 2]);
      case n of
        1..6, 8: Rectangle(x - 6, y - 6, x + 6, y + 6);
        7:
        begin
          Brush.Color := Col2;
          Ellipse(x - 12, y - 12, x + 12, y + 12);
        end;
      end;
    end;
  end;
end;

procedure Aff_Delta;
var
  v1, v2: integer;
begin
  with WdMain do
  begin
    v2 := 0;
    if (EdMaxi.Text <> '') and (EdMini.Text <> '') then
    begin
      v1 := StrToInt(EdMaxi.Text);
      v2 := StrToInt(EdMini.Text);
      v2 := Abs(v2 - v1);
    end;
    if v2 = 0 then
      EdDelta.Text := ''
    else
      EdDelta.Text := IntToStr(v2);
  end;
end;

procedure Temps_Init;
var
  k, xr, yr: real;
  MaxX, MaxY: integer;
  DeltaX, DeltaY: integer;
  m, n, p, x, y: integer;
begin
  with WdMain do
  begin
    MaxX := Img1.Width;
    MaxY := Img1.Height;
    with Img1.Canvas do
    begin
      //Clear
      Pen.Color := ClCream;
      for n := 0 to MaxX do
        Line(n, 0, n, MaxY);
      //Centre 150,150
      Brush.Color := ClBlue;
      Rectangle(140, 140, 160, 160);
      //-
      //----- Création Horloge -----
      //-
      //Création POSITIONS et affichage des minutes
      k := 9.44;
      //k:=11.01;
      n := 0;
      repeat
        xr := 150 + 120 * sin(k);
        yr := 150 + 120 * cos(k);
        Minutes[n, 1] := xr;
        Minutes[n, 2] := yr;
        Rectangle(Round(xr - 2), Round(yr - 2), Round(xr + 2), Round(yr + 2));
        k := k - 0.1045;
        Inc(n);
      until (k < 3.24) or (n > 59);
      //-
      //----- Aiguilles -----
      //-
      //Récup. AIGUILLES des Minutes à partir des positions des Minutes
      //Centre : 150,150
      for m := 0 to 59 do
      begin
        //Centre
        x := 150;
        y := 150;
        //-
        DeltaX := Round(Abs(x - Minutes[m, 1]) / 11);
        DeltaY := Round(Abs(y - Minutes[m, 2]) / 11);
        p := 0;
        //-
        for n := 1 to 7 do
        begin
          if n > 1 then
          begin
            Inc(p);
            if p in [1..6] then
            begin
              Min[m, p, 1] := x;
              Min[m, p, 2] := y;
            end;
          end;
          case m of
            0..15:
            begin
              Inc(x, DeltaX);
              Dec(y, DeltaY);
            end;
            16..30:
            begin
              Inc(x, DeltaX);
              Inc(y, DeltaY);
            end;
            31..45:
            begin
              Dec(x, DeltaX);
              Inc(y, DeltaY);
            end;
            46..59:
            begin
              Dec(x, DeltaX);
              Dec(y, DeltaY);
            end;
          end;
        end;
      end;
      //-
      //Récup. aiguille des Secondes à partir des Minutes
      //Centre : 150,150
      for m := 0 to 59 do
      begin
        //Centre
        x := 150;
        y := 150;
        //-
        DeltaX := Round(Abs(x - Minutes[m, 1]) / 11);
        DeltaY := Round(Abs(y - Minutes[m, 2]) / 11);
        n := 1;
        p := 0;
        //-
        repeat
          if n > 1 then
          begin
            Inc(p);
            if p in [1..8] then
            begin
              Sec[m, p, 1] := x;
              Sec[m, p, 2] := y;
            end;
          end;
          case m of
            0..15:
            begin
              Inc(x, DeltaX);
              Dec(y, DeltaY);
            end;
            16..30:
            begin
              Inc(x, DeltaX);
              Inc(y, DeltaY);
            end;
            31..45:
            begin
              Dec(x, DeltaX);
              Inc(y, DeltaY);
            end;
            46..59:
            begin
              Dec(x, DeltaX);
              Dec(y, DeltaY);
            end;
          end;
          Inc(n);
        until n > 8;
      end;
      //Récup. Heures à partir des aiguilles des Minutes
      for m := 0 to 59 do
      begin
        for n := 1 to 4 do
        begin
          Heu[m, n, 1] := Min[m, n, 1];
          Heu[m, n, 2] := Min[m, n, 2];
        end;
      end;
      //-
      //Affiche Cadran des Heures et Minutes
      Affiche_Cadran;
    end;
  end;
end;

procedure Grid_Aff_Ligne;
begin
  with WdMain do
    PaY.Caption := IntToStr(StringGrid1.Row);
end;

procedure Grid_Ligne_Vide(y: integer);
var
  x: integer;
begin
  for x := 1 to DataMaxX_ do
    WdMain.StringGrid1.Cells[x, y] := '';
end;

procedure Grid_Vide;
var
  n: integer;
begin
  with WdMain do
  begin
    with StringGrid1 do
    begin
      Color := ClCream;
      for n := 1 to DataMax_ do
        Grid_Ligne_Vide(n);
      Row := 1;
    end;
    Grid_Aff_Ligne;
  end;
end;

procedure Grid_Init;
var
  n: integer;
begin
  with WdMain do
  begin
    with StringGrid1 do
    begin
      ColCount := DataMaxX_ + 1;
      DefaultRowHeight := 19;
      //Ligne 0 + Taille du StrigGrdi(1..DataMax_)
      RowCount := DataMax_ + 1;
      //Colonne 0
      ColWidths[0] := 30;
      for n := 1 to DataMax_ do
        Cells[0, n] := IntToStr(n);
      //-
      ColWidths[1] := 90;
      Cells[1, 0] := 'Date';
      ColWidths[2] := 70;
      Cells[2, 0] := 'Heure';
      ColWidths[3] := 70;
      Cells[3, 0] := 'Maxima';
      ColWidths[4] := 70;
      Cells[4, 0] := 'Minima';
      ColWidths[5] := 70;
      Cells[5, 0] := 'Pulsation';
      ColWidths[6] := 260;
      Cells[6, 0] := 'Produit 1';
      ColWidths[7] := 260;
      Cells[7, 0] := 'Produit 2';
      ColWidths[8] := 260;
      Cells[8, 0] := 'Produit 3';
      ColWidths[9] := 260;
      Cells[9, 0] := 'Produit 4';
      ColWidths[10] := 260;
      Cells[10, 0] := 'Produit 5';
      ColWidths[11] := 260;
      Cells[11, 0] := 'Produit 6';
      ColWidths[12] := 260;
      Cells[12, 0] := 'Produit 7';
      ColWidths[13] := 260;
      Cells[13, 0] := 'Produit 8';
      ColWidths[14] := 260;
      Cells[14, 0] := 'Produit 9';
      ColWidths[15] := 260;
      Cells[15, 0] := 'Produit 10';
      Row := 1;
    end;
    Grid_Vide;
  end;
end;

procedure Produits_Init;
begin
  with WdProduits do
  begin
    EdModif.Text := '';
    PaCount.Caption := '0';
  end;
end;

procedure Valide_Derniere_Ligne;
var
  n: integer;
begin
  with WdMain do
  begin
    n := Derniere_Ligne(StringGrid1.Row + 1) + 2;
    if n > StringGrid1.RowCount - 1 then
    begin
      StringGrid1.Row := StringGrid1.RowCount - 1;
    end
    else
    begin
      StringGrid1.Row := n;
      if n > 1 then
        StringGrid1.Row := n - 1;
    end;
  end;
end;

procedure Grid_vers_Data;
var
  Max, n, p: integer;
begin
  with WdMain do
  begin
    with StringGrid1 do
    begin
      Max := StringGrid1.RowCount - 1;
      for n := 1 to DataMax_ do
      begin
        if n > Max then
        begin
          with Data[n] do
          begin
            DateS := '';
            HeureS := '';
            Maxi := '';
            Mini := '';
            Pulse := '';
            for p := 1 to ProduitsMax_ do
              Produits[p] := '';
          end;
        end
        else
        begin
          with Data[n] do
          begin
            DateS := Cells[1, n];
            HeureS := Cells[2, n];
            Maxi := Cells[3, n];
            Mini := Cells[4, n];
            Pulse := Cells[5, n];
            for p := 1 to ProduitsMax_ do
              Produits[p] := Cells[5 + p, n];
          end;
        end;
      end;
    end;
  end;
end;

procedure Data_Vide;
var
  n, p: integer;
begin
  for n := 1 to DataMax_ do
    with WdMain.Data[n] do
    begin
      DateS := '';
      HeureS := '';
      Maxi := '';
      Mini := '';
      Pulse := '';
      for p := 1 to ProduitsMax_ do
        Produits[p] := '';
    end;
end;

function Data_Sauver(Fichier: string): boolean;
var
  f: file of Data_;
  Ok: boolean;
begin
  Ok := False;
  //-
  Grid_vers_Data;
  //-
  with WdMain do
  begin
    AssignFile(f, Fichier);
    {$i-}
    Rewrite(f);
    {$i+}
    if Ioresult = 0 then
    begin
      {$i-}
      Write(f, Data);
      if Ioresult = 0 then
        Ok := True;
      {$i+}
    end
    else
    begin
      ShowMessage('Sauvegarde du fichier ' + ExtractFileName(Fichier) +
        ' impossible.');
    end;
    {$i-}
    CloseFile(f);
    {$i+}
  end;
  Result := Ok;
end;

procedure Data_Lire;
var
  f: file of Data_;
  n, p, x: integer;
  Ok: boolean;
begin
  with WdMain do
  begin
    Ok := False;
    {$i-}
    AssignFile(f, DataFile);
    {$i+}
    {$i-}
    Reset(f);
    {$i+}
    if Ioresult = 0 then
    begin
      {$i-}
      Read(f, Data);
      {$i+}
      if Ioresult = 0 then
      begin
        Ok := True;
      end
      else
      begin
        ShowMessage('Lecture du fichier "' + ExtractFileName(DataFile) +
          '" impossible.');
      end;
      {$i-}
      CloseFile(f);
      {$i+}
    end;
    if Ok then
    begin
      for n := 1 to DataMax_ do
      begin
        for x := 1 to DataMaxX_ do
          StringGrid1.Cells[x, n] := '';
        with StringGrid1 do
        begin
          with Data[n] do
          begin
            Cells[1, n] := DateS;
            Cells[2, n] := HeureS;
            Cells[3, n] := Maxi;
            Cells[4, n] := Mini;
            Cells[5, n] := Pulse;
            for p := 1 to ProduitsMax_ do
              Cells[5 + p, n] := Produits[p];
          end;
        end;
      end;
      StringGrid1.Row := 1;
      Valide_Derniere_Ligne;
    end
    else
    begin
      StringGrid1.Row := 1;
    end;
  end;
end;

procedure Data_Nouveau;
var
  Fichier, s: string;
  s1, s2: string;
  t1, t2: string;
  n: integer;
begin
  with WdMain do
  begin
    s1 := '';
    t1 := DateToStr(Now);
    for n := 1 to Length(t1) do
      if If_Chiffre0_9(t1[n]) then
        s1 := s1 + t1[n];
    //-
    s2 := '';
    t2 := TimeToStr(Now);
    for n := 1 to Length(t2) do
      if If_Chiffre0_9(t2[n]) then
        s2 := s2 + t2[n];
    s := s1 + '-' + s2;
    //Data
    Fichier := DirExe + 'MiMaPulse-' + s + '.dat';
    ShowMessage('Date   : ' + t1 + #9#10 + 'Heure : ' + t2 + #9#10 + #9#10 +
      'Nouveau fichier de données : ' + ExtractFileName(Fichier));
    if Data_Sauver(Fichier) then
    begin
      DataFile := Fichier;
      Version;
    end;
    //Produits
    if MessageDlg('Ré-initialiser le fichier des produits ?', mtConfirmation,
      [mbYes, mbNo, mbIgnore], 0) = mrYes then
    begin
      with WdProduits do
      begin
        //Init. Box
        with ListBox1 do
        begin
          Clear;
          for n := 1 to ProduitsMax_ do
            Items.Add('');
          Items.SaveToFile(WdMain.DirExe + ProduitsNom_);
        end;
      end;
    end;
  end;
end;

procedure Produits_Lire;
var
  Txt: TextFile;
  Fichier, s: string;
  n: integer;
begin
  with WdProduits do
  begin
    //Init. Box
    with ListBox1 do
    begin
      Clear;
      for n := 1 to ProduitsMax_ do
        Items.Add('');
    end;
    //Lecture des produits
    Fichier := WdMain.DirExe + ProduitsNom_;
    AssignFile(Txt, Fichier);
    {$i-}
    Reset(Txt);
    {$i+}
    if Ioresult = 0 then
    begin
      n := 0;
      repeat
        {$i-}
        Readln(Txt, s);
        if (Ioresult = 0) and (s <> '') then
        begin
          ListBox1.Items[n] := s;
          Inc(n);
        end;
        {$i+}
      until (EOF(Txt)) or (n > ProduitsMax_ - 1);
      {$i-}
      CloseFile(Txt);
      {$i+}
    end;
    with ListBox1 do
    begin
      ItemIndex := 0;
      PaCount.Caption := '1/' + IntToStr(Items.Count);
      WdMain.EdProduit1.Text := Items[0];
      WdMain.EdProduit2.Text := Items[1];
    end;
  end;
end;

procedure Sauver_CSV;
var
  Txt: Textfile;
  Ligne: string;
  y: integer;
begin
  with WdMain do
  begin
    {$i-}
    AssignFile(Txt, DirExe + CSVNom_);
    {$i+}
    {$i-}
    Rewrite(Txt);
    {$i+}
    if Ioresult = 0 then
    begin
      y := 1;
      repeat
        with StringGrid1 do
        begin
          Ligne := Cells[1, y] + ';' + Cells[2, y] + ';' + Cells[3, y] +
            ';' + Cells[4, y] + ';' + Cells[5, y] + ';' + Cells[6, y] + ';';
          {$i-}
          Writeln(Txt, Ligne);
          {$i+}
        end;
        Inc(y);
      until y > DataMax_;
      {$i-}
      CloseFile(Txt);
      {$i+}
      ShowMessage('          Sauvegarde en format CSV terminé.');
    end
    else
    begin
      ShowMessage('          Ouverture du fichier ' + CSVNom_ + ' impossible.');
    end;
  end;
end;

procedure Lire_CSV;
var
  Txt: Textfile;
  s, t: string;
  n, p, q: integer;
  Ok: boolean;
begin
  with WdMain do
  begin
    Ok := False;
    if MessageDlg('Charger un fichier de données CSV ?', mtConfirmation,
      [mbYes, mbNo, mbIgnore], 0) = mrYes then
      Ok := True;
    if Ok then
    begin
      with OpenDialog1 do
      begin
        InitialDir := DirExe;
        FileName := '*.csv';
        if Execute then
        begin
          AssignFile(Txt, FileName);
          {$i-}
          Reset(Txt);
          {$i+}
          if Ioresult = 0 then
          begin
            n := 0;
            repeat
              {$i-}
              Readln(Txt, s);
              {$i+}
              if Ioresult = 0 then
              begin
                if n > 0 then
                begin
                  p := 1;
                  q := 0;
                  t := '';
                  repeat
                    if s[p] = ';' then
                    begin
                      Inc(q);
                      WdMain.StringGrid1.Cells[q, n] := t;
                      t := '';
                    end
                    else
                    begin
                      t := t + s[p];
                    end;
                    Inc(p);
                  until p > Length(s);
                  if q = 4 then
                    WdMain.StringGrid1.Cells[5, n] := t;
                end;
                Inc(n);
              end;
            until (EOF(Txt)) or (n > DataMax_);
            {$i-}
            CloseFile(Txt);
            {$i+}
            ShowMessage('    Lecture du fichier CSV terminé.' +
              #9#10 + #9#10 +
              '    Les données ne seront sauvées que lorsque vous ' +
              #9#10 + '    aurez cliqué sur le bouton de sauvegarde.');
          end;
        end;
      end;
    end;
  end;
end;

procedure Pad_Color;
begin
  with WdMain do
  begin
    case Select of
      1: PaPad.Color := ColVert_;
      2: PaPad.Color := ColBleu_;
      3: PaPad.Color := ColJaune_;
    end;
  end;
end;

procedure Saisie_Vide;
begin
  with WdMain do
  begin
    EdMaxi.Text := '';
    EdMini.Text := '';
    EdDelta.Text := '';
    EdPulse.Text := '';
  end;
end;

procedure Saisie_Init;
begin
  with WdMain do
  begin
    EdMaxi.Text := '';
    EdMini.Text := '';
    EdPulse.Text := '';
    Select := 1;
    Pad_Color;
    ActiveControl := EdMaxi;
  end;
end;

procedure Saisie_vers_Data;
var
  n, y: integer;
begin
  with WdMain do
  begin
    y := StringGrid1.Row;
    StringGrid1.Cells[1, y] := DateToStr(Now);
    StringGrid1.Cells[2, y] := TimeToStr(Now);
    StringGrid1.Cells[3, y] := EdMaxi.Text;
    StringGrid1.Cells[4, y] := EdMini.Text;
    StringGrid1.Cells[5, y] := EdPulse.Text;
    for n := 1 to ProduitsMax_ do
      StringGrid1.Cells[5 + n, y] := WdProduits.ListBox1.Items[n - 1];
    //-
    Saisie_Vide;
    if StringGrid1.Row < DataMax_ then
      StringGrid1.Row := StringGrid1.Row + 1;
    Grid_Aff_Ligne;
  end;
end;

procedure Data_vers_Saisie;
var
  s: string;
  y: integer;
begin
  with WdMain do
  begin
    y := StringGrid1.Row;
    Grid_Aff_Ligne;
    Saisie_Init;
    EdMaxi.Text := StringGrid1.Cells[3, y];
    EdMini.Text := StringGrid1.Cells[4, y];
    EdPulse.Text := StringGrid1.Cells[5, y];
    if not ChDTreel.Checked then
    begin
      EdDate.Text := StringGrid1.Cells[1, y];
      s := StringGrid1.Cells[2, y];
      PaHr.Caption := s;
      if Length(s) = 8 then
      begin
        EdHeures.Text := Copy(s, 1, 2);
        EdMinutes.Text := Copy(s, 4, 2);
        EdSecondes.Text := Copy(s, 7, 2);
      end
      else
      begin
        EdHeures.Text := '';
        EdMinutes.Text := '';
        EdSecondes.Text := '';
      end;
    end;
    //-
    Select := 1;
    Pad_Color;
    ActiveControl := EdMaxi;
    EdMaxi.SelStart := Length(EdMaxi.Text);
  end;
end;

procedure Pad_Suppression;
var
  s: string;
begin
  with WdMain do
  begin
    case Select of
      1: if EdMaxi.Text <> '' then
        begin
          s := EdMaxi.Text;
          Delete(s, Length(s), 1);
          EdMaxi.Text := s;
          EdMaxi.SelStart := Length(EdMaxi.Text);
        end;
      2: if EdMini.Text <> '' then
        begin
          s := EdMini.Text;
          Delete(s, Length(s), 1);
          EdMini.Text := s;
          EdMini.SelStart := Length(EdMini.Text);
        end;
      3: if EdPulse.Text <> '' then
        begin
          s := EdPulse.Text;
          Delete(s, Length(s), 1);
          EdPulse.Text := s;
          EdPulse.SelStart := Length(EdPulse.Text);
        end;
    end;
  end;
end;

procedure Pad_Validation;
begin
  with WdMain do
  begin
    case Select of
      1:
      begin
        Select := 2;
        Pad_Color;
        ActiveControl := EdMini;
        EdMini.SelStart := Length(EdMini.Text);
      end;
      2:
      begin
        Aff_Delta;
        Select := 3;
        Pad_Color;
        ActiveControl := EdPulse;
        EdPulse.SelStart := Length(EdPulse.Text);
      end;
      3:
      begin
        Saisie_vers_Data;
        Select := 1;
        Pad_Color;
        ActiveControl := EdMaxi;
        EdMaxi.SelStart := Length(EdMaxi.Text);
      end;
    end;
  end;
end;

procedure Pad_Ajout(s: string);
begin
  with WdMain do
  begin
    case Select of
      1: if Length(EdMaxi.Text) < 3 then
        begin
          EdMaxi.Text := EdMaxi.Text + s;
          EdMaxi.SelStart := Length(EdMaxi.Text);
        end;
      2: if Length(EdMini.Text) < 3 then
        begin
          EdMini.Text := EdMini.Text + s;
          EdMini.SelStart := Length(EdMini.Text);
        end;
      3: if Length(EdPulse.Text) < 3 then
        begin
          EdPulse.Text := EdPulse.Text + s;
          EdPulse.SelStart := Length(EdPulse.Text);
        end;
    end;
  end;
end;

procedure Select_Pos;
begin
  with WdMain do
  begin
    case Select of
      1:
      begin
        Pad_Color;
        ActiveControl := EdMaxi;
        EdMaxi.SelStart := Length(EdMaxi.Text);
      end;
      2:
      begin
        Pad_Color;
        ActiveControl := EdMini;
        EdMini.SelStart := Length(EdMini.Text);
      end;
      3:
      begin
        Pad_Color;
        ActiveControl := EdPulse;
        EdPulse.SelStart := Length(EdPulse.Text);
      end;
    end;
  end;
end;

procedure Grid_Ligne_Efface;
var
  n, p: integer;
begin
  with WdMain.StringGrid1 do
  begin
    for n := 1 to DataMaxX_ do
    begin
      //StringGrid Clean
      Cells[n, Row] := '';
      //Data Clean
      with WdMain.Data[n] do
      begin
        DateS := '';
        HeureS := '';
        Maxi := '';
        Mini := '';
        Pulse := '';
        for p := 1 to ProduitsMax_ do
          Produits[p] := '';
      end;
    end;
  end;
end;

//----- Moindres carres -----
procedure TWdMain.Moindres_carres(Select, Debut, Fin: integer; var a, b: real;
  var Ydebut, Yfin: integer);
const
  Tmax_ = 4;
var
  Liste: array[1..GrWinMax_, 1..TMax_] of real;
  SommeXi, SommeYi: real;
  Somme1, Somme2: real;
  //Xb:Xbarre=Moyenne des X
  //Yb:Ybarre=Moyenne des Y
  Xb, Yb: real;
  Xi, Yi, n, p: integer;
  NbYi: integer;
begin
  with WdGraphe do
  begin
    //Clear Solutions
    for n := 1 to GrWinMax_ do
      for p := 1 to Tmax_ do
        Liste[n, p] := 0;
    //Bilan
    Xi := 0;
    Yi := 0;
    NbYi := 0;
    SommeXi := 0;
    SommeYi := 0;
    for n := 1 to GrWinMax_ do
    begin
      case Select of
        //Maxima
        1: Yi := WdMain.Convert(WdMain.StringGrid1.Cells[3, Debut + n - 1]);
        //Minima
        2: Yi := WdMain.Convert(WdMain.StringGrid1.Cells[4, Debut + n - 1]);
        //Pulsation
        3: Yi := WdMain.Convert(WdMain.StringGrid1.Cells[5, Debut + n - 1]);
      end;
      if Yi > 0 then
      begin
        //Xb=Somme(Xi)/n. Moyenne X de la suite 1,2,3...
        SommeXi := SommeXi + Xi;
        //Yb=Somme(Yi)/n. Moyenne Y des Maxima
        SommeYi := SommeYi + Yi;
        //Total
        Inc(NbYi);
      end;
      Inc(Xi);
    end;
    //Xb
    if NbYi > 0 then
      Xb := SommeXi / NbYi
    else
      Xb := 0;
    //Yb
    if NbYi > 0 then
      Yb := SommeYi / NbYi
    else
      Yb := 0;
    //-
    if (Xb > 0) and (Yb > 0) then
    begin
      //Sommes de Tab3 et Tab4
      SommeXi := 0;
      SommeYi := 0;
      Yi := 0;
      p := 1;
      for n := 1 to GrWinMax_ do
      begin
        case Select of
          //Maxima
          1: Yi := WdMain.Convert(WdMain.StringGrid1.Cells[3, Debut + n - 1]);
          //Minima
          2: Yi := WdMain.Convert(WdMain.StringGrid1.Cells[4, Debut + n - 1]);
          //Pulsation
          3: Yi := WdMain.Convert(WdMain.StringGrid1.Cells[5, Debut + n - 1]);
        end;
        if Yi > 0 then
        begin
          //Tab1 : Xi-Xb
          Liste[p, 1] := Xi - Xb;
          //Tab2 : Yi-Yb
          Liste[p, 2] := Yi - Yb;
          //Tab3 : (Xi-Xb)²
          Liste[p, 3] := Sqr(Liste[p, 1]);
          //Tab4 : (Xi-Xb)(Yi-Yb)
          Liste[p, 4] := Abs(Liste[p, 1] * Liste[p, 2]);
          //-
          Inc(NbYi);
        end;
        Inc(p);
      end;
      //-
      Somme1 := 0;
      Somme2 := 0;
      p := 1;
      for n := 1 to GrWinMax_ do
      begin
        if Liste[p, 3] > 0 then
          Somme1 := Somme1 + Liste[p, 3];
        if Liste[p, 4] > 0 then
          Somme2 := Somme2 + Liste[p, 4];
        Inc(Xi);
        Inc(p);
      end;
      //----- a de ax+b -----
      a := Somme2 / Somme1;
      //----- b de ax+b -----
      b := Yb - (a * Xb);
      //Droite d'équation ax+b : 1er valeur v1
      //Ydebut:=a*v1+b;
      case Select of
        //Maxima
        1:
        begin
          Yi := WdMain.Convert(WdMain.StringGrid1.Cells[3, Debut]);
          Ydebut := Round((a * Yi) + b);
        end;
        //Minima
        2:
        begin
          Yi := WdMain.Convert(WdMain.StringGrid1.Cells[4, Debut]);
          Ydebut := Round((a * Yi) + b);
        end;
        //Pulsation
        3:
        begin
          Yi := WdMain.Convert(WdMain.StringGrid1.Cells[5, Debut]);
          Ydebut := Round((a * Yi) + b);
        end;
      end;
      //yDebut:=Round(MaxGY-y);
      //Yfin:=a*vn+b;
      //Droite d'équation ax+b : Dernière valeur
      case Select of
        //Maxima
        1:
        begin
          Yi := WdMain.Convert(WdMain.StringGrid1.Cells[3, Fin]);
          Yfin := Round((a * Yi) + b);
        end;
        //Minima
        2:
        begin
          Yi := WdMain.Convert(WdMain.StringGrid1.Cells[4, Fin]);
          Yfin := Round((a * Yi) + b);
        end;
        //Pulsation
        3:
        begin
          Yi := WdMain.Convert(WdMain.StringGrid1.Cells[5, Fin]);
          Yfin := Round((a * Yi) + b);
        end;
      end;
    end
    else
    begin
      YDebut := 0;
      YFin := 0;
    end;
  end;
end;

function TWDMain.LES_3(a: real; v0, v1, v2, v3: integer): integer;
begin
  //Lissage Exponentiel simple
  Result := Round((a * v0) + (a * (1 - a) * v1) + (a * Power(1 - a, 2) * v2) + (a * Power(1 - a, 3) * v3));
end;

procedure TWdMain.MenuItem6Click(Sender: TObject);
begin
  WdMain.Close;
end;

procedure TWdMain.MenuItem7Click(Sender: TObject);
begin
  WdGraphe.ShowModal;
end;

procedure TWdMain.MenuItem9Click(Sender: TObject);
begin
  WdGraphe3.ShowModal;
end;

procedure TWdMain.Pa1Click(Sender: TObject);
begin

end;

procedure TWdMain.PaPad0Click(Sender: TObject);
begin
  Pad_Ajout('0');
end;

procedure TWdMain.PaPad1Click(Sender: TObject);
begin
  Pad_Ajout('1');
end;

procedure TWdMain.PaPad2Click(Sender: TObject);
begin
  Pad_Ajout('2');
end;

procedure TWdMain.PaPad3Click(Sender: TObject);
begin
  Pad_Ajout('3');
end;

procedure TWdMain.PaPad4Click(Sender: TObject);
begin
  Pad_Ajout('4');
end;

procedure TWdMain.PaPad5Click(Sender: TObject);
begin
  Pad_Ajout('5');
end;

procedure TWdMain.PaPad6Click(Sender: TObject);
begin
  Pad_Ajout('6');
end;

procedure TWdMain.PaPad7Click(Sender: TObject);
begin
  Pad_Ajout('7');
end;

procedure TWdMain.PaPad8Click(Sender: TObject);
begin
  Pad_Ajout('8');
end;

procedure TWdMain.PaPad9Click(Sender: TObject);
begin
  Pad_Ajout('9');
end;

procedure TWdMain.PaPadDelClick(Sender: TObject);
begin
  Pad_Suppression;
end;

procedure TWdMain.PaPadVClick(Sender: TObject);
begin
  Pad_Validation;
end;

procedure TWdMain.PaPulse0Click(Sender: TObject);
begin

end;

procedure TWdMain.SpdEffLigneClick(Sender: TObject);
begin
  if MessageDlg('       Effacer la ligne courante ? ', mtConfirmation,
    [mbYes, mbNo, mbIgnore], 0) = mrYes then
    Grid_Ligne_Efface;
end;

procedure TWdMain.SpeedButton1Click(Sender: TObject);
begin
  Copie_Presse_Papier;
  ShowMessage('La fenêtre courante a été copiée dans le presse-papier.');
end;

procedure TWdMain.SpeedButton2Click(Sender: TObject);
begin
  WdGraphe.ShowModal;
end;

procedure TWdMain.SpeedButton3Click(Sender: TObject);
begin
  StringGrid1.Row := Champ_Vide;
end;

procedure TWdMain.SpeedButton4Click(Sender: TObject);
begin
  WdGraphe3.ShowModal;
end;

procedure TWdMain.Timer1Timer(Sender: TObject);
var
  HMSM: TTime;
  s: string;
begin
  Aff_Heures(MemHeu, MemMin, ClWhite);
  Aff_Minutes(MemMin, ClWhite);
  Aff_Secondes(MemSec, ClWhite, ClWhite);
  //-
  HMSM := Now;
  DecodeTime(HMSM, Heure, Minute, Seconde, MilliSec);
  MemHeu := Heure;
  MemMin := Minute;
  MemSec := Seconde;
  //-
  if ChDTreel.Checked then
  begin
    EdDate.Text := DateToStr(Now);
    //Heures
    s := IntToStr(Heure);
    if Length(s) <> 2 then
      s := '0' + s;
    EdHeures.Text := s;
    //Minutes
    s := IntToStr(Minute);
    if Length(s) <> 2 then
      s := '0' + s;
    EdMinutes.Text := s;
    //Secondes
    s := IntToStr(Seconde);
    if Length(s) <> 2 then
      s := '0' + s;
    EdSecondes.Text := s;
  end;
  PaHr.Caption := TimeToStr(Now);
  //-
  Aff_Heures(Heure, Minute, ColOrange_);
  Aff_Minutes(Minute, ColBleu_);
  Aff_Secondes(Seconde, ColRose_, ColAig_);
end;

procedure TWdMain.Timer2Timer(Sender: TObject);
begin
  Timer2.Enabled := False;
  //Aide
  if WdAide.CkAide.Checked then
    WdAide.ShowModal;
end;

procedure TWdMain.SpSauveClick(Sender: TObject);
begin
  Data_Sauver(DataFile);
  //-
  StringGrid1.Color := ColRouge_;
  StringGrid1.Update;
  Sleep(100);
  StringGrid1.Color := ClCream;
  Select := 1;
  Pad_Color;
end;

procedure TWdMain.SpFinClick(Sender: TObject);
begin
  Data_vers_Saisie;
  Valide_Derniere_Ligne;
end;

procedure TWdMain.SpDebutClick(Sender: TObject);
begin
  StringGrid1.Row := 1;
  Data_vers_Saisie;
end;

procedure TWdMain.SpHautClick(Sender: TObject);
begin
  with StringGrid1 do
  begin
    if Row > 1 then
    begin
      Row := Row - 1;
      Data_vers_Saisie;
    end;
  end;
end;

procedure TWdMain.SpBasClick(Sender: TObject);
begin
  with StringGrid1 do
  begin
    if Row < DataMax_ then
    begin
      Row := Row + 1;
      Data_vers_Saisie;
    end;
  end;
end;

procedure TWdMain.SpValClick(Sender: TObject);
var
  He, Mi, Se, s: string;
  p: integer;
begin
  p := StringGrid1.Row;
  //Date
  s := EdDate.Caption;
  if Length(s) = 10 then
    StringGrid1.Cells[1, p] := s
  else
    StringGrid1.Cells[1, p] := '00/00/0000';
  //Heures
  He := EdHeures.Caption;
  case Length(He) of
    0: He := '00';
    1: He := '0' + He;
  end;
  EdHeures.Caption := He;
  //Minutes
  Mi := EdMinutes.Caption;
  case Length(Mi) of
    0: Mi := '00';
    1: Mi := '0' + Mi;
  end;
  EdMinutes.Caption := Mi;
  //Secondes
  Se := EdSecondes.Caption;
  case Length(Se) of
    0: Se := '00';
    1: Se := '0' + Se;
  end;
  EdSecondes.Caption := Se;
  //-
  StringGrid1.Cells[2, p] := He + '/' + Mi + '/' + Se;
end;

procedure TWdMain.StringGrid1Click(Sender: TObject);
begin
  Data_vers_Saisie;
  Aff_Delta;
end;

procedure TWdMain.StringGrid1MouseWheel(Sender: TObject; Shift: TShiftState;
  WheelDelta: integer; MousePos: TPoint; var Handled: boolean);
begin
  Grid_Aff_Ligne;
end;

procedure TWdMain.MenuItem4Click(Sender: TObject);
var
  Ext: string;
begin
  with OpenDialog1 do
  begin
    InitialDir := DirExe;
    FileName := '*.dat';
    if Execute then
    begin
      Ext := LowerCase(ExtractFileExt(FileName));
      if Ext = '.dat' then
      begin
        DataFile := FileName;
        Data_Vide;
        Saisie_Vide;
        Grid_Vide;
        Data_Lire;
        Saisie_Init;
        Grid_Aff_Ligne;
        Version;
      end;
    end;
  end;
end;

procedure TWdMain.MenuItem2Click(Sender: TObject);
begin
  Data_Sauver(DataFile);
end;

procedure TWdMain.MenuItem3Click(Sender: TObject);
begin
  Sauver_CSV;
end;

procedure TWdMain.MenuItem5Click(Sender: TObject);
begin
  Lire_CSV;
end;

procedure TWdMain.EdMaxiClick(Sender: TObject);
begin
  Select := 1;
  Select_Pos;
end;

procedure TWdMain.EdMaxiChange(Sender: TObject);
begin
  Aff_Delta;
end;

procedure TWdMain.ChDTreelChange(Sender: TObject);
begin
  if ChDTreel.Checked then
  begin
    with EdDate do
    begin
      Cursor := crDefault;
      Color := $00BFD5FF;
      ReadOnly := True;
    end;
    with EdHeures do
    begin
      Cursor := crDefault;
      ReadOnly := True;
      Color := $00BFD5FF;
    end;
    with EdMinutes do
    begin
      Cursor := crDefault;
      ReadOnly := True;
      Color := $00BFD5FF;
    end;
    with EdSecondes do
    begin
      Cursor := crDefault;
      EdSecondes.ReadOnly := True;
      Color := $00BFD5FF;
    end;
    SpVal.Enabled := False;
    SpVal.Cursor := crDefault;
  end
  else
  begin
    with EdDate do
    begin
      Cursor := crHandPoint;
      ReadOnly := False;
      Color := $00C2BAF5;
    end;
    with EdHeures do
    begin
      Cursor := crHandPoint;
      ReadOnly := False;
      Color := $00C2BAF5;
    end;
    with EdMinutes do
    begin
      Cursor := crHandPoint;
      ReadOnly := False;
      Color := $00C2BAF5;
    end;
    with EdSecondes do
    begin
      Cursor := crHandPoint;
      ReadOnly := False;
      Color := $00C2BAF5;
    end;
    SpVal.Enabled := True;
    SpVal.Cursor := crHandPoint;
    ActiveControl := EdDate;
    EdDate.SelStart := Length(EdDate.Text);
  end;
end;

procedure TWdMain.EdMiniClick(Sender: TObject);
begin
  Select := 2;
  Select_Pos;
end;

procedure TWdMain.EdMaxiKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
begin
  case Key of
    8, 110: Pad_Suppression;
    9, 13, 40: Pad_Validation;
    96..105: Pad_Ajout(Key_Convert(Key));
  end;
  Key := 0;
end;

procedure TWdMain.EdMiniChange(Sender: TObject);
begin
  Aff_Delta;
end;

procedure TWdMain.EdMiniKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
begin
  case Key of
    8, 110: Pad_Suppression;
    9, 13, 40: Pad_Validation;
    38:
    begin
      Select := 1;
      Select_Pos;
    end;
    96..105: Pad_Ajout(Key_Convert(Key));
  end;
  Key := 0;
end;

procedure TWdMain.EdProduit1Click(Sender: TObject);
begin
  WdProduits.ShowModal;
end;

procedure TWdMain.EdProduit2Click(Sender: TObject);
begin
  WdProduits.ShowModal;
end;

procedure TWdMain.EdPulseClick(Sender: TObject);
begin
  Select := 3;
  Select_Pos;
end;

procedure TWdMain.EdPulseKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
begin
  case Key of
    8, 110: Pad_Suppression;
    9, 13, 40: Pad_Validation;
    38:
    begin
      Select := 2;
      Select_Pos;
    end;
    96..105: Pad_Ajout(Key_Convert(Key));
  end;
  Key := 0;
end;

procedure TWdMain.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
  Ini_Sauve;
end;

procedure TWdMain.MenuItem10Click(Sender: TObject);
begin
  WdProduits.ShowModal;
end;

procedure TWdMain.MenuItem11Click(Sender: TObject);
begin
  if MessageDlg('   Nouveau fichier de données Data (O/N) ?', mtConfirmation,
    [mbYes, mbNo, mbIgnore], 0) = mrYes then
  begin
    //Init
    Grid_Init;
    //Clean
    Data_Vide;
    Saisie_Vide;
    Data_Nouveau;
    Saisie_Init;
  end;
end;

procedure TWdMain.MenuItem12Click(Sender: TObject);
begin
  WdAide.ShowModal;
end;

procedure TWdMain.FormShow(Sender: TObject);
begin
  WdMain.Width := 772;
  WdMain.Height := 690;
  //-
  DirExe := ExtractFilePath(Application.ExeName);
  if DirExe[Length(DirExe)] <> '\' then
    DirExe := DirExe + '\';
  //Init
  Temps_Init;
  Grid_Init;
  Produits_Init;
  //Clean
  Data_Vide;
  Saisie_Vide;
  //Lecture
  Ini_Lire;
  Produits_Lire;
  if FileExists(DataFile) then
  begin
    Data_Lire;
    Version;
  end
  else
  begin
    if MessageDlg('Création d''un nouveau fichier de données ' +
      '(Oui=Yes, Non=No) ?   ', mtConfirmation,
      [mbYes, mbNo, mbIgnore], 0) = mrYes then
    begin
      StringGrid1.Color := ClCream;
      Data_Nouveau;
    end
    else
    begin
      DataFile := DirExe + DataNom_;
      StringGrid1.Color := ColRouge_;
    end;
  end;
  //-
  //Timer
  DecodeTime(Now, Heure, Minute, Seconde, MilliSec);
  if Heure > 11 then
    Heure := Heure - 12;
  MemHeu := Heure;
  MemMin := Minute;
  MemSec := Seconde;
  //-
  Timer1.Enabled := True;
  Timer2.Enabled := True;
  //-
  Data_vers_Saisie;
  Saisie_Init;
end;

end.
