unit mimapulse_produits;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, Buttons;

type

  { TWdProduits }

  TWdProduits = class(TForm)
    EdModif: TEdit;
    GroupBox4: TGroupBox;
    Label3: TLabel;
    Label4: TLabel;
    LaSauve: TLabel;
    ListBox1: TListBox;
    Pa0: TPanel;
    PaCount: TPanel;
    Pa3: TPanel;
    PaDepl: TPanel;
    SpdBas: TSpeedButton;
    SpdDebut: TSpeedButton;
    SpdFin: TSpeedButton;
    SpdHaut: TSpeedButton;
    SpdModif: TSpeedButton;
    SpeedButton4: TSpeedButton;
    procedure EdModifKeyDown(Sender: TObject; var Key: word; Shift: TShiftState);
    procedure EdMoinsClick(Sender: TObject);
    procedure EdPlusClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure ListBox1Click(Sender: TObject);
    procedure SpdDebutClick(Sender: TObject);
    procedure SpdFinClick(Sender: TObject);
    procedure SpdModifClick(Sender: TObject);
    procedure SpdHautClick(Sender: TObject);
    procedure SpdBasClick(Sender: TObject);
    procedure SpeedButton4Click(Sender: TObject);
  private
    { private declarations }
  public
    { public declarations }
  end;

var
  WdProduits: TWdProduits;

implementation

uses mimapulse_main;

{$R *.lfm}

{ TWdProduits }

function Prd_Recherche(s: string): integer;
var
  n, p: integer;
begin
  p := -1;
  n := 0;
  with WdProduits.ListBox1 do
  begin
    repeat
      if Items[n] = s then
        p := n;
      Inc(n);
    until (p > 0) or (n > Items.Count - 1);
  end;
  Result := p;
end;

procedure Affiche_Ligne;
begin
  with WdProduits do
  begin
    PaCount.Caption := IntToStr(ListBox1.ItemIndex + 1) +
      '/' + IntToStr(ListBox1.Items.Count);
  end;
end;

procedure Produits_Clean;
begin
  with WdProduits do
  begin
    EdModif.Text := '';
    Affiche_Ligne;
  end;
end;

procedure Produits_Sauve;
begin
  with WdProduits do
  begin
    LaSauve.Color := ClRed;
    LaSauve.Update;
    Sleep(200);
    ListBox1.Items.SaveToFile(WdMain.DirExe + ProduitsNom_);
    LaSauve.Color := $0051A8FF;
  end;
end;

procedure Valide;
begin
  with WdProduits do
  begin
    if ListBox1.Items.Count > 0 then
    begin
      ListBox1.Items[ListBox1.ItemIndex] := EdModif.Text;
      Produits_Clean;
      Produits_Sauve;
    end;
  end;
end;

procedure Selection;
begin
  with WdProduits do
  begin
    if ListBox1.ItemIndex >= 0 then
    begin
      Affiche_Ligne;
      EdModif.Text := ListBox1.Items[ListBox1.ItemIndex];
      ActiveControl := EdModif;
      EdModif.SelStart := Length(EdModif.Text);
    end;
  end;
end;

procedure TWdProduits.EdPlusClick(Sender: TObject);
begin
  EdModif.Text := '';
  if ListBox1.Items.Count > 0 then
  begin
    ListBox1.ItemIndex := ListBox1.Items.Count - 1;
    if listBox1.Items[ListBox1.ItemIndex] <> '' then
    begin
      ListBox1.Items.Add('');
      ListBox1.ItemIndex := ListBox1.Items.Count - 1;
      Affiche_Ligne;
    end;
  end;
end;

procedure TWdProduits.EdMoinsClick(Sender: TObject);
begin
  EdModif.Text := '';
end;

procedure TWdProduits.EdModifKeyDown(Sender: TObject; var Key: word;
  Shift: TShiftState);
begin
  if Key = 13 then
  begin
    Valide;
    Key := 0;
  end;
end;

procedure TWdProduits.ListBox1Click(Sender: TObject);
begin
  Selection;
end;

procedure TWdProduits.SpdDebutClick(Sender: TObject);
begin
  with ListBox1 do
  begin
    ItemIndex := 0;
    EdModif.Text := ListBox1.Items[ListBox1.ItemIndex];
    Affiche_Ligne;
  end;
end;

procedure TWdProduits.SpdFinClick(Sender: TObject);
begin
  with ListBox1 do
  begin
    ItemIndex := Items.Count - 1;
    EdModif.Text := ListBox1.Items[ListBox1.ItemIndex];
    Affiche_Ligne;
  end;
end;

procedure TWdProduits.SpdModifClick(Sender: TObject);
begin
  Valide;
end;

procedure TWdProduits.SpdHautClick(Sender: TObject);
begin
  with ListBox1 do
  begin
    if Items.Count > 0 then
    begin
      if ItemIndex > 0 then
        ItemIndex := ItemIndex - 1
      else
        ItemIndex := 0;
      EdModif.Text := ListBox1.Items[ListBox1.ItemIndex];
      Affiche_Ligne;
    end;
  end;
end;

procedure TWdProduits.SpdBasClick(Sender: TObject);
begin
  with ListBox1 do
  begin
    if Items.Count > 0 then
    begin
      if ItemIndex < Items.Count - 1 then
        ItemIndex := ItemIndex + 1
      else
        ItemIndex := Items.Count - 1;
      EdModif.Text := ListBox1.Items[ListBox1.ItemIndex];
      Affiche_Ligne;
    end;
  end;
end;

procedure TWdProduits.SpeedButton4Click(Sender: TObject);
begin
  WdMain.EdProduit1.Text := WdProduits.ListBox1.Items[0];
  WdMain.EdProduit2.Text := WdProduits.ListBox1.Items[1];
  WdProduits.Close;
end;

procedure TWdProduits.FormShow(Sender: TObject);
begin
  Produits_Clean;
  Affiche_Ligne;
  ListBox1.ItemIndex := 0;
  Selection;
end;

end.
